<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin_fw.php';
require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';
require_once 'lib/control_factory.php';
require_once 'lib/action_factory.php';
require_once 'lib/list_util.php';

require_once 'utils.php';

require 'cursor.php';
require 'folder.php';
require 'folder_cache.php';
require 'playback_url_cache.php';
require 'video_cache.php';
$link_api = link_api();
if (file_exists($link_api))
require $link_api;
else
require 'link_api.php';

///////////////////////////////////////////////////////////////////////////

$hd_interface_language = 'english';

///////////////////////////////////////////////////////////////////////////

function link_api()
{
	$upd = false;
	$link = '/tmp/plugins/link_api.php';
	$vers1 = file_get_contents('http://dune-club.info/plugins/update/link_api.txt');
	if ($vers1 == true){
		preg_match('|##(.*?)##|', $vers1, $matches1);
		if (file_exists($link)){
			$vers2 = file_get_contents($link);
			preg_match('|##(.*?)##|', $vers2, $matches2);
			if ($matches1[1]>$matches2[1])
				$upd = true;
		}
		if ((($matches1[1] == true)&&($upd == true)) || (!file_exists($link))){
			$data = fopen($link,"w");
				if (!$data)
				echo "$link save false";
				fwrite($data, $vers1);
				@fclose($data);
		}
	}	
	return $link;
}
///////////////////////////////////////////////////////////////////////////

function get_interface_language()
{
    global $hd_interface_language;
    return $hd_interface_language;
}

function is_interface_language_russian_or_similar()
{
    return get_interface_language() === 'russian' ||
        get_interface_language() === 'ukrainian';
}

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

class GeneralPlugin extends DefaultDunePlugin implements UserInputHandler
{
    const ID = 'General';
    ///////////////////////////////////////////////////////////////////////
    // sersar # code start
    private $oMediaUrl = null;
    // sersar # code end
	private $allMediaUrl = null;
	private $searchQ = null;
    private $fav_build_in_progess;
	private $m_last_ref;
    private static $open_folder_action = array
    (
        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
    );

    ///////////////////////////////////////////////////////////////////////

    private static $vod_play_action = array
    (
        GuiAction::handler_string_id => PLUGIN_VOD_PLAY_ACTION_ID,
        GuiAction::caption           => 'Play'
    );

    ///////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////

    private static $catalog_vip = array
    (
        ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
        ViewItemParams::item_layout => HALIGN_LEFT,
        ViewItemParams::icon_valign => VALIGN_CENTER,
        ViewItemParams::icon_dx => 20,
        ViewItemParams::icon_dy => -5,
        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
        ViewItemParams::item_caption_width => 1550
    );

    public static function get_skin_path($plugin_cookies)
    {
        $skin = isset($plugin_cookies->skin) ? $plugin_cookies->skin : 'default';
        
        $skins = array
        (
            'default' =>  'plugin_file://skins/default/',
            'juniperus' => 'plugin_file://skins/juniperus/'
        );
        
        return $skins[$skin];
    }

    public static function get_main_vip($plugin_cookies)
    {
        $skin = isset($plugin_cookies->skin) ? $plugin_cookies->skin : 'default';
        
        $skins = array
        (
            'default' =>  array
                            (
                                ViewItemParams::icon_scale_factor =>0.75,
                                ViewItemParams::icon_sel_scale_factor =>1,
                                ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                                ViewItemParams::item_layout => VALIGN_CENTER,
                                ViewItemParams::icon_valign => VALIGN_CENTER,
                                ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL
                            ),
            'juniperus' =>    array
                            (
                                ViewItemParams::icon_scale_factor =>1.0,        //jun
                                ViewItemParams::icon_sel_scale_factor =>1.1,        //jun
                                ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
                                ViewItemParams::item_layout => VALIGN_CENTER,
                                ViewItemParams::icon_valign => VALIGN_CENTER,
                                ViewItemParams::item_caption_dy => -50,                     //jun
                                ViewItemParams::item_caption_sel_dy => -15,                //jun
                                ViewItemParams::icon_dy => -14,                            //jun
                                ViewItemParams::icon_sel_dy => -14,                         //jun
                                ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL
                            )
        );
        
        return $skins[$skin];
    }

    public static function get_main_menu_folder_view($plugin_cookies)
    {
        $skin = isset($plugin_cookies->skin) ? $plugin_cookies->skin : 'default';
        if (HD::plugin_login($plugin_cookies) == true)
			$num_cols = 3;
		else
			$num_cols = 2;
        $skins = array
        (
            'juniperus' =>  array
                            (
                                ViewParams::num_cols => $num_cols,        //jun
                                ViewParams::num_rows => 2,        //jun
                                ViewParams::icon_selection_box_dx => -118,        //jun
                                ViewParams::icon_selection_box_dy => -154,        //jun
                                ViewParams::icon_selection_box_width => 240,        //jun
                                ViewParams::icon_selection_box_height => 240,        //jun
                                ViewParams::paint_sandwich => false,                    //jun
                                ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                                ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                                ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                                ViewParams::sandwich_width => 200,            //jun
                                ViewParams::sandwich_height => 200,         //jun
                                ViewParams::sandwich_icon_upscale_enabled => false,        //jun
                                ViewParams::paint_details => true
                            ),
            'default' =>    array
                            (
                                ViewParams::num_cols => $num_cols,
                                ViewParams::num_rows => 2,
                                ViewParams::icon_selection_box_dx => -130,
                                ViewParams::icon_selection_box_dy => -130,
                                ViewParams::icon_selection_box_width => 360,
                                ViewParams::icon_selection_box_height => 200,
                                ViewParams::paint_sandwich => true,
                                ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                                ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                                ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                                ViewParams::sandwich_width => 360,
                                ViewParams::sandwich_height => 200,
                                ViewParams::sandwich_icon_upscale_enabled => true,
                                ViewParams::paint_details => true
                            ),
        );
        
        return $skins[$skin];
    }

    public function __construct()
    {
        $this->fav_build_in_progess = false;
    }

    private static function get_preview_url($v)
    {
        if (!HD::has_attribute($v, 'season_image'))
            return '';

        return $v->season_image;
    }

    ///////////////////////////////////////////////////////////////////////
    public function get_play_action($media_url, &$plugin_cookies)
    {
        $add_play_action = UserInputHandlerRegistry::create_action(
                        $this, 'play_item');
        $add_play_action['caption'] = (
                '%tr%show_tv_main'
                );

        return $add_play_action;
    }

    ///////////////////////////////////////////////////////////////////////
    public function get_item_action_map($media_url, &$plugin_cookies)
    {
        $add_fav_action = UserInputHandlerRegistry::create_action(
                        $this, 'add_favorite');
        $add_fav_action['caption'] = (
                '%tr%add_favorite'
                );
		$show_related_view = UserInputHandlerRegistry::create_action(
                        $this, 'related_view');
        $switch_view = UserInputHandlerRegistry::create_action(
                        $this, 'switch_view');
        $switch_view['caption'] = (
                '%tr%view_mode'
                );
        $view_info = UserInputHandlerRegistry::create_action(
                        $this, 'ex_view_info');
        $view_info['caption'] = (
                '%tr%info'
                );
		$search_view = UserInputHandlerRegistry::create_action(
                        $this, 'do_search_menu');
        $search_view['caption'] = '%tr%search';
		$sort_page = UserInputHandlerRegistry::create_action(
                        $this, 'sort_page');
        $sort_page['caption'] = '%tr%sorting';
		$popup_action = UserInputHandlerRegistry::create_action(
                        $this, 'pop_up_menu');
        
		$setup_view = UserInputHandlerRegistry::create_action(
                        $this, 'setup');
        $setup_view['caption'] = '%tr%settings';
        $skip_details = isset($plugin_cookies->skip_details) ? $plugin_cookies->skip_details : 'no';

        if ($skip_details === 'yes')
        {
            return array
                (
                GUI_EVENT_KEY_ENTER => UserInputHandlerRegistry::create_action($this, 'view_series'),
                GUI_EVENT_KEY_PLAY => $this->get_play_action($media_url, $plugin_cookies),
                GUI_EVENT_KEY_A_RED => $switch_view,
                GUI_EVENT_KEY_INFO => $view_info,
				GUI_EVENT_KEY_B_GREEN => $search_view,
				GUI_EVENT_KEY_D_BLUE => $sort_page,
                GUI_EVENT_KEY_C_YELLOW => $add_fav_action,
				GUI_EVENT_KEY_POPUP_MENU => $popup_action,
				GUI_EVENT_KEY_SETUP => $setup_view,
				GUI_EVENT_KEY_SELECT => $show_related_view,
            );
            
        }
        else
        {
            return array
                (
                GUI_EVENT_KEY_ENTER => $view_info,
                GUI_EVENT_KEY_PLAY => $this->get_play_action($media_url, $plugin_cookies),
                GUI_EVENT_KEY_A_RED => $switch_view,
				GUI_EVENT_KEY_B_GREEN => $search_view,
                GUI_EVENT_KEY_C_YELLOW => $add_fav_action,
				GUI_EVENT_KEY_D_BLUE => $sort_page,
				GUI_EVENT_KEY_POPUP_MENU => $popup_action,
				GUI_EVENT_KEY_SETUP => $setup_view,
				GUI_EVENT_KEY_SELECT => $show_related_view,
            );
            
        }
    }

    ///////////////////////////////////////////////////////////////////////
    public function get_search_action_map($media_url, &$plugin_cookies)
    {
        $search_playlist_action = UserInputHandlerRegistry::create_action(
                        $this, 'search_playlist');
        $search_playlist_action['caption'] = (
                '%tr%search_playlists'
                );
		$search_channel_action = UserInputHandlerRegistry::create_action(
                        $this, 'search_channel');
        $search_channel_action['caption'] = (
                '%tr%search_channels'
                );
		$search_all_action = UserInputHandlerRegistry::create_action(
                        $this, 'search_all');
        $search_all_action['caption'] = (
                '%tr%search_all'
                );
		$remove_search_action = UserInputHandlerRegistry::create_action(
                        $this, 'remove_search');
        $remove_search_action['caption'] = (
                '%tr%remove'
                );
        $move_search_top_action = UserInputHandlerRegistry::create_action(
                        $this, 'move_search_top');
        $move_search_top_action['caption'] = (
                '%tr%move_to_top'
                );
		$move_search_top_one_action = UserInputHandlerRegistry::create_action(
                        $this, 'move_search_top_one');
        $move_search_top_one_action['caption'] = (
                '%tr%move_up'
                );
		$move_search_low_one_action = UserInputHandlerRegistry::create_action(
                        $this, 'move_search_low_one');
        $move_search_low_one_action['caption'] = (
                '%tr%move_down'
                );
        $menu_items[] = array(
            GuiMenuItemDef::caption => $move_search_top_action['caption'],
           GuiMenuItemDef::action => $move_search_top_action
        );
		$menu_items[] = array(
            GuiMenuItemDef::caption => $move_search_top_one_action['caption'],
           GuiMenuItemDef::action => $move_search_top_one_action
        );
		$menu_items[] = array(
            GuiMenuItemDef::caption => $move_search_low_one_action['caption'],
           GuiMenuItemDef::action => $move_search_low_one_action
        );
        $menu_items[] = array(
            GuiMenuItemDef::caption => $remove_search_action['caption'],
            GuiMenuItemDef::action => $remove_search_action
        );
        $popup_search_action = ActionFactory::show_popup_menu($menu_items);
        $do_search_action = UserInputHandlerRegistry::create_action($this, 'do_search');
		
		$setup_view = UserInputHandlerRegistry::create_action(
                        $this, 'setup');
        $setup_view['caption'] = '%tr%settings';
        return array
            (
            GUI_EVENT_KEY_ENTER => $do_search_action,
            GUI_EVENT_KEY_POPUP_MENU => $popup_search_action,
			GUI_EVENT_KEY_B_GREEN => $search_playlist_action,
			GUI_EVENT_KEY_C_YELLOW => $search_channel_action,
			GUI_EVENT_KEY_D_BLUE => $search_all_action,
			GUI_EVENT_KEY_SETUP => $setup_view,
        );
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_fav_action_map($media_url, &$plugin_cookies)
    {
        $remove_fav_action = UserInputHandlerRegistry::create_action(
                        $this, 'remove_fav');
        $remove_fav_action['caption'] = (
                '%tr%remove'
                );
        $move_fav_top_action = UserInputHandlerRegistry::create_action(
                        $this, 'move_fav_top');
        $move_fav_top_action['caption'] = (
                 '%tr%move_to_top'
                );
		$move_fav_top_one_action = UserInputHandlerRegistry::create_action(
                        $this, 'move_fav_top_one');
        $move_fav_top_one_action['caption'] = (
                '%tr%move_up'
                );
		$move_fav_low_one_action = UserInputHandlerRegistry::create_action(
                        $this, 'move_fav_low_one');
        $move_fav_low_one_action['caption'] = (
                '%tr%move_down'
                );
        $switch_view = UserInputHandlerRegistry::create_action(
                        $this, 'switch_view');
        $switch_view['caption'] = (
                '%tr%view_mode'
                );
        $view_info = UserInputHandlerRegistry::create_action(
                        $this, 'ex_view_info');
        $view_info['caption'] = (
                '%tr%info'
                );
       $menu_items[] = array(
            GuiMenuItemDef::caption => $remove_fav_action['caption'],
            GuiMenuItemDef::action => $remove_fav_action
        );
	   $menu_items[] = array(
            GuiMenuItemDef::caption => $move_fav_top_action['caption'],
            GuiMenuItemDef::action => $move_fav_top_action
        );
		$menu_items[] = array(
            GuiMenuItemDef::caption => $move_fav_top_one_action['caption'],
            GuiMenuItemDef::action => $move_fav_top_one_action
        );
		$menu_items[] = array(
            GuiMenuItemDef::caption => $move_fav_low_one_action['caption'],
            GuiMenuItemDef::action => $move_fav_low_one_action
        );
        $sort_page = UserInputHandlerRegistry::create_action(
                        $this, 'sort_page');
        $sort_page['caption'] = '%tr%sorting';
        $popup_fav_action = ActionFactory::show_popup_menu($menu_items);
		$setup_view = UserInputHandlerRegistry::create_action(
                        $this, 'setup');
        $setup_view['caption'] = ('%tr%settings');
		$search_view = UserInputHandlerRegistry::create_action(
                        $this, 'do_search_menu');
        $search_view['caption'] = '%tr%search';
        $skip_details = isset($plugin_cookies->skip_details) ? $plugin_cookies->skip_details : 'no';

        if ($skip_details === 'yes')
        {
            return array
                (
                GUI_EVENT_KEY_ENTER => UserInputHandlerRegistry::create_action($this, 'view_series'),
                GUI_EVENT_KEY_PLAY => $this->get_play_action($media_url, $plugin_cookies),
                GUI_EVENT_KEY_A_RED => $switch_view,
                GUI_EVENT_KEY_INFO => $view_info,
                GUI_EVENT_KEY_POPUP_MENU => $popup_fav_action,
				//GUI_EVENT_KEY_D_BLUE => $sort_page,
				GUI_EVENT_KEY_SETUP => $setup_view,
				GUI_EVENT_KEY_B_GREEN => $search_view,
            );
        }
        else
        {
            return array
                (
                GUI_EVENT_KEY_ENTER => $view_info,
                GUI_EVENT_KEY_PLAY => $this->get_play_action($media_url, $plugin_cookies),
                GUI_EVENT_KEY_A_RED => $switch_view,
                GUI_EVENT_KEY_POPUP_MENU => $popup_fav_action,
				GUI_EVENT_KEY_D_BLUE => $sort_page,
				GUI_EVENT_KEY_SETUP => $setup_view,
				GUI_EVENT_KEY_B_GREEN => $search_view,
            );
        }
    }

    ///////////////////////////////////////////////////////////////////////
    public function get_video_action_map($media_url, &$plugin_cookies) 
    {
        $setup_view = UserInputHandlerRegistry::create_action(
                        $this, 'setup');
        $setup_view['caption'] = ('%tr%settings');
		return array
            (
				GUI_EVENT_KEY_ENTER => self::$open_folder_action,
				GUI_EVENT_KEY_SETUP => $setup_view,
			);
    }
	public function get_category_action_map($media_url, &$plugin_cookies) 
    {
        $sort_page = UserInputHandlerRegistry::create_action(
                        $this, 'country_and_localization');
        $sort_page['caption'] = '%tr%c_and_l';
		$setup_view = UserInputHandlerRegistry::create_action(
                        $this, 'setup');
        $setup_view['caption'] = ('%tr%settings');
		return array
            (
            GUI_EVENT_KEY_ENTER => self::$open_folder_action,
			GUI_EVENT_KEY_B_GREEN => $sort_page,
			GUI_EVENT_KEY_SETUP => $setup_view,
			);
    }
	public function do_get_add_mypl_defs(&$plugin_cookies ,$handler)
    {
		$defs = array();
		$dune_mypl = '0';
		$dune_mypl_ops[0] = '%tr%select_playlist';
		$jsd = HD::get_authorization_document(HOST_API_URL. "/playlists?part=snippet&maxResults=50&mine=true&key=" . API_KEY . "&pageToken=", &$plugin_cookies);
		$video = array();
		$video = $jsd['items'];
		if (isset($jsd['nextPageToken'])){
			$i=0;
			$m_last_ref = $jsd['nextPageToken'];
			$jsdn = HD::get_authorization_document(HOST_API_URL. "/playlists?part=snippet&maxResults=50&mine=true&key=" . API_KEY . "&pageToken=$m_last_ref", &$plugin_cookies);
			$video = array_merge($video,$jsdn['items']);
			do {
				++$i;
			if (isset($jsdn['nextPageToken'])){
			$m_last_ref = $jsdn['nextPageToken'];
			$jsdn = HD::get_authorization_document(HOST_API_URL. "/playlists?part=snippet&maxResults=50&mine=true&key=" . API_KEY . "&pageToken=$m_last_ref", &$plugin_cookies);
			$video = array_merge($video,$jsdn['items']);
			}
			else
				break;
			} while ($i = 25);
		}
		foreach ($video as $value)
		$dune_mypl_ops[$value['id']] = $value['snippet']['title'];
		ControlFactory::add_combobox($defs, $this, null,
            'mypl_names', '',
            $dune_mypl, $dune_mypl_ops, 1000, $need_confirm = false, $need_apply = false
        );
		ControlFactory::add_label($defs, "", '%tr%dialog_7');
		$mypl_name = '';
		ControlFactory::add_text_field($defs,
            $handler, $add_params=null,
            'mypl_name', '',
            $mypl_name, 0, 0, 0, 1, 1000);

		$apply_new_mypl = UserInputHandlerRegistry::create_action($this, 'apply_new_mypl');
        ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'apply_new_mypl', '%tr%add', 500, $apply_new_mypl);
		
        ControlFactory::add_close_dialog_button($defs,
            'Назад', 500);
        return $defs;
    }
	public function ver()
    {
	$ver = file_get_contents(DuneSystem::$properties['install_dir_path'].'/dune_plugin.xml');
		if (is_null($ver)) {
				hd_print('Can`t load dune_plugin.xml');
				return 'n/a';
			}
		$xml = HD::parse_xml_document($ver);
	$plugin_version = strval($xml->version);
	return $plugin_version;
	}
	public function yt_channel_ico($channelId)
    {
	$ico_path = 'plugin_file://skins/6.png';
	$ico_array = array (0=>0,1=>4,10=>1,17=>2,18=>4,20=>3,30=>4,31=>4,23=>4,25=>5,7=>7,);
	if (isset ($ico_array[$channelId]))
	$ico_path = 'plugin_file://skins/'.$ico_array[$channelId].'.png';
	return $ico_path;
	}
    ///////////////////////////////////////////////////////////////////////
    public function get_main_menu_action_map($media_url, &$plugin_cookies)
    {
		$ver = self::ver();
		$setup_view = UserInputHandlerRegistry::create_action(
                        $this, 'setup');
        $setup_view['caption'] = '%tr%settings';
		
		$info_release = UserInputHandlerRegistry::create_action(
                        $this, 'info_release');
        $info_release['caption'] = $ver;
		
		$sort_page = UserInputHandlerRegistry::create_action(
                        $this, 'sort_page');
        $sort_page['caption'] = '%tr%sorting';
		if (HD::plugin_login($plugin_cookies) == true){
			$popup_action = UserInputHandlerRegistry::create_action(
                        $this, 'unlogin_page');
		$popup_action['caption'] = '%tr%logout';
		}
		else{
		$popup_action = UserInputHandlerRegistry::create_action(
                        $this, 'login_page');
		$popup_action['caption'] = '%tr%login';
		}
		$login_action = UserInputHandlerRegistry::create_action(
                        $this, 'move_mm_top');
        $login_action['caption'] = '%tr%move_to_top';
				
		$menu_items[] = array(
            GuiMenuItemDef::caption => $login_action['caption'],
            GuiMenuItemDef::action => $login_action
        );
		$up_action = ActionFactory::show_popup_menu($menu_items);
        return array
            (
            GUI_EVENT_KEY_ENTER => self::$open_folder_action,
			GUI_EVENT_KEY_B_GREEN => $setup_view,
			GUI_EVENT_KEY_SETUP => $setup_view,
            GUI_EVENT_KEY_C_YELLOW => $popup_action,
			GUI_EVENT_KEY_D_BLUE => $sort_page,
			GUI_EVENT_KEY_POPUP_MENU => $up_action,
			GUI_EVENT_KEY_INFO => $info_release,
        );
    }

    ///////////////////////////////////////////////////////////////////////
    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        //update_interface_language();
        $do_search_action = UserInputHandlerRegistry::create_action($this, 'do_search');
        $do_new_search_action = UserInputHandlerRegistry::create_action($this, 'do_new_search');
        $perform_new_search_action = UserInputHandlerRegistry::create_action($this, 'perform_new_search');
        $do_mark_viewed = UserInputHandlerRegistry::create_action($this, 'mark_viewed');
        $add_fav_complite = UserInputHandlerRegistry::create_action($this, 'add_fav_complite');
        $del_fav_complite = UserInputHandlerRegistry::create_action($this, 'del_fav_complite');
        $just_play = UserInputHandlerRegistry::create_action($this, 'just_play');
		$add_fav = UserInputHandlerRegistry::create_action($this, 'add_favorite');
        $remove_fav = UserInputHandlerRegistry::create_action($this, 'remove_fav');
		$do_search_menu = UserInputHandlerRegistry::create_action($this, 'do_search_menu');
		$do_similar_menu = UserInputHandlerRegistry::create_action($this, 'related_view');
		$do_dload_menu = UserInputHandlerRegistry::create_action($this, 'dload');
		$do_all_playlist = UserInputHandlerRegistry::create_action($this, 'all_playlist');
		$do_video_like = UserInputHandlerRegistry::create_action($this, 'video_like');
		$do_video_dislike = UserInputHandlerRegistry::create_action($this, 'video_dislike');
		$do_video_nonelike = UserInputHandlerRegistry::create_action($this, 'video_nonelike');
		$do_video_watchLater = UserInputHandlerRegistry::create_action($this, 'video_watchLater');
		$do_video_favorites = UserInputHandlerRegistry::create_action($this, 'video_favorites');
		$do_add_to_playlist = UserInputHandlerRegistry::create_action($this, 'add_to_playlist');
		$do_add_subscription = UserInputHandlerRegistry::create_action($this, 'add_subscription');
		$do_delete_from_playlist = UserInputHandlerRegistry::create_action($this, 'delete_from_playlist');
		$do_chanel_view = UserInputHandlerRegistry::create_action($this, 'chanel_view');
		$do_add_reload = UserInputHandlerRegistry::create_action($this, 'add_reload');
        if (isset($user_input->control_id))
        {
            $control_id = $user_input->control_id;
            switch ($control_id)
            {
                case 'search':
                    $new_value = $user_input->{$control_id};
                    HD::save_item('search_item', $new_value,&$plugin_cookies);
                    $defs = $this->do_get_search_defs($plugin_cookies);
                    return  ActionFactory::reset_controls
                            (
                                $defs,
                                null,
                                1
                            );
                case 'perform_new_search':
                    $new_value = HD::get_item('search_item', &$plugin_cookies);
                    $search_text = urlencode($new_value);
					HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					$ser_link ='video';
					if ($this->serchQ !== null)
					$ser_link = $this->serchQ;
					$search_url = HD::encode_user_data(array('ser_feed' => $search_text, 'ser_link' => $ser_link));
                    return array
                    (
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                        GuiAction::data =>
                        array
                        (
                            'media_url' => $search_url
                        )
                    );
                case 'do_new_search':
					$this->serchQ = $user_input->selected_control_id;
                    $new_value = HD::get_item('search_item', &$plugin_cookies);
                    $search_items = HD::get_items('search_items', &$plugin_cookies);
					$k = array_search($new_value, $search_items);
					if ($k !== false)
					unset ($search_items [$k]);
					array_unshift($search_items, $new_value); 
					HD::save_items('search_items', $search_items,&$plugin_cookies);
                    return ActionFactory::invalidate_folders(array('main_menu:search'), $perform_new_search_action);
                case 'do_search':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    if ($user_data->ser_feed != '')
                        break;

                    $defs = $this->do_get_search_defs($plugin_cookies);
                    return ActionFactory::show_dialog(
                            '%tr%search',
                            $defs,
								true);
                    
                    break;
				case 'do_search_menu':
					HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					$title = '';
                    if (HD::has_attribute($user_data, 'episode_title'))
                        $title = $user_data->episode_title;
                    else if (HD::has_attribute($user_data, 'season_title'))
                        $title = $user_data->season_title;
                    HD::save_item('search_item', $title,&$plugin_cookies);
                    $defs = $this->do_get_search_defs($plugin_cookies);
                    return ActionFactory::show_dialog(
                        '%tr%search',
                            $defs,
								true);
                    
                    break;
				case 'use_marked':
				$use_marked = $user_input->use_marked;
				$defs = array();
				if ($use_marked == 'yes'){
				ControlFactory::add_label($defs, '%tr%attention', '%tr%dialog_14');
				ControlFactory::add_label($defs, "", '%tr%dialog_15');
				ControlFactory::add_label($defs, "", '%tr%dialog_16');
				ControlFactory::add_label($defs, "", '%tr%dialog_17');
				ControlFactory::add_label($defs, "", '%tr%dialog_18');
				$use_marked_applay = UserInputHandlerRegistry::create_action($this, 'use_marked_applay');
				$use_reset_controls = UserInputHandlerRegistry::create_action($this, 'use_reset_controls');
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'use_marked_applay', '%tr%yes', 250, $use_marked_applay);
				ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'use_reset_controls', '%tr%no', 250, $use_reset_controls);
				return  ActionFactory::show_dialog ('%tr%use_marked',$defs,	true);
				}else{
				HD::save_item('use_marked', 'no',&$plugin_cookies);
				return  ActionFactory::reset_controls
                            (
                                $this->do_get_control_defs($plugin_cookies)
                            );
				}
				break;
				case 'use_marked_applay':
                    HD::save_item('use_marked', 'yes',&$plugin_cookies);
					return  ActionFactory::reset_controls
                            (
                                $this->do_get_control_defs($plugin_cookies)
                            );
                    break;
				case 'use_reset_controls':
					return  ActionFactory::reset_controls
                            (
                                $this->do_get_control_defs($plugin_cookies)
                            );
                    break;
                case 'skin':
                    $new_value = $user_input->{$control_id};
                    $plugin_cookies->skin = $new_value;
                    shell_exec("cp -f ".DuneSystem::$properties['install_dir_path']."/skins/$new_value/icons/logo.png ".DuneSystem::$properties['install_dir_path']."/skins/logo.png");
					shell_exec("cp -f ".DuneSystem::$properties['install_dir_path']."/skins/$new_value/icons/default.png ".DuneSystem::$properties['install_dir_path']."/skins/default.png");
					$defs = $this->do_get_reboot_defs();
					return  ActionFactory::show_dialog
					('%tr%restart_needed',
					$defs,
					true);
                    break;
				case 'data_type':
                    $new_value = $user_input->{$control_id};
					if (($new_value == 2)&&(!file_exists('/D/YouTube_data:')))
					mkdir('/D/YouTube_data');
                    $plugin_cookies->data_type = $new_value;
                    return ActionFactory::reset_controls(
                            $this->do_get_control_defs($plugin_cookies)
                    );
                    break;
				case 'export_YouTube_data':
					if (!file_exists('/D/'))
					return ActionFactory::show_title_dialog('%tr%connect_the_drive_to_the_player_and_try_again');
					$mci = DuneSystem::$properties['data_dir_path'];
					if (!file_exists('/D/YouTube_data'))
						mkdir('/D/YouTube_data');
					shell_exec("cp -r $mci/* /D/YouTube_data/");
					return ActionFactory::show_title_dialog('%tr%folder_unloaded');  
                    break;
				case 'import_YouTube_data':
					if (!file_exists('/D/YouTube_data/'))
					return ActionFactory::show_title_dialog('%tr%folder_not_found');
					$mci = DuneSystem::$properties['data_dir_path'];
					shell_exec("cp -r /D/YouTube_data/* $mci");
					return ActionFactory::show_title_dialog('%tr%folder_loaded'); 
                    break;
				case 'export_data':
                   $defs = $this->do_get_export_data_defs($plugin_cookies, $this);
					return  ActionFactory::show_dialog
							(
								'%tr%folder_data',
								$defs,
								true
							);
                    break;
				case 'data_dir':
				$plugin_cookies->data_dir = $user_input->data_dir;
				return ActionFactory::reset_controls(
                            $this->do_get_control_defs($plugin_cookies)
                    );
                break;
				case 'dload_dir':
				$plugin_cookies->dload_dir = $user_input->dload_dir;
				return ActionFactory::reset_controls(
                            $this->do_get_control_defs($plugin_cookies)
                    );
                break;
				case 'data_path_smb':
				$defs = $this->do_get_data_path_smb_defs($plugin_cookies);
					
					return  ActionFactory::show_dialog
							(
								'%tr%the_path_username_and_password_smb_folder',
								$defs,
								true
							);
				break;
				case 'dload_path_smb':
				$defs = $this->do_get_dload_path_smb_defs($plugin_cookies);
					
					return  ActionFactory::show_dialog
							(
								'%tr%the_path_username_and_password_smb_folder',
								$defs,
								true
							);
				break;
				case 'data_path_smb_apply':
				$plugin_cookies->data_smb_user = $user_input->data_smb_user;
				$plugin_cookies->data_smb_pass = $user_input->data_smb_pass;
				$plugin_cookies->data_ip_path = $user_input->data_ip_path;
				return ActionFactory::reset_controls(
                            $this->do_get_control_defs($plugin_cookies)
                    );
                break;
				case 'dload_path_smb_apply':
				$plugin_cookies->dload_smb_user = $user_input->dload_smb_user;
				$plugin_cookies->dload_smb_pass = $user_input->dload_smb_pass;
				$plugin_cookies->dload_ip_path = $user_input->dload_ip_path;
				return ActionFactory::reset_controls(
                            $this->do_get_control_defs($plugin_cookies)
                    );
                break;
				case 'additional':
                    HD::decode_user_data($user_input->parent_media_url, $media_str, $user_data);
					$selection = $user_data->video_id;
                    $from_fav = false;
                    $fav_items = HD::get_items('fav_items', &$plugin_cookies);
                    if (in_array($user_data->video_id, $fav_items))
                        $from_fav = true;
                    $defs = array();
                    ControlFactory::add_custom_close_dialog_and_apply_buffon
                    (
                        $defs,
                        '_favorites',
                         ($from_fav ? '%tr%remove_from_favorites' : '%tr%add_favorite'),
                          550,
                          ($from_fav ? $remove_fav : $add_fav)
                    );
                    ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_search', '%tr%search', 550, $do_search_menu);
					if ($user_data->playlistItem==0){
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_related_view', '%tr%show_related_videos', 550, $do_similar_menu);
					if (file_exists('/tmp/yt'))
						$text = '%tr%download_info';
					else
						$text = '%tr%download_yvd';
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_dload_view', $text, 550, $do_dload_menu);
					}
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_chanel_view', '%tr%open_video_channel', 550, $do_chanel_view);
                    if (HD::plugin_login($plugin_cookies) == true)
					{	if ($user_data->playlistItem==0){
						$jsd = HD::get_authorization_document(HOST_API_URL."/videos/getRating?id=".$user_data->video_id."&key=".API_KEY, &$plugin_cookies);
						if ($jsd['items']['0']['rating']== 'none'){
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_like', '%tr%add_a_like', 550, $do_video_like);
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_dislike', '%tr%add_a_dislike', 550, $do_video_dislike);
						}
						else
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_nonelike', '%tr%add_a_nonelike', 550, $do_video_nonelike);
						
						$jsd_cd = HD::get_authorization_document(HOST_API_URL."/channels?part=contentDetails&maxResults=50&mine=true&key=".API_KEY, &$plugin_cookies);
						$w = $jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['watchLater'];
						$f = $jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['favorites'];
						if (!preg_match("|$w|",$user_input->parent_media_url))
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_watchLater', '%tr%add_a_watchlater', 550, $do_video_watchLater);
						if (!preg_match("|$f|",$user_input->parent_media_url))
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_favorites', '%tr%add_a_favorites', 550, $do_video_favorites);
						if ((HD::has_attribute($user_data, 'itemID'))&&($user_data->itemID==true))
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_delete_from_playlist', '%tr%delete_from_playlist', 550, $do_delete_from_playlist);
						ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_add_to_playlist', '%tr%add_to_playlist', 550, $do_add_to_playlist);
						ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_add_subscription', '%tr%add_subscription', 550, $do_add_subscription);
						}
						if ($user_data->playlistItem==1)
							if ((HD::has_attribute($user_data, 'itemID'))&&($user_data->itemID==true))
								ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_delete_from_playlist', '%tr%delete_playlist', 550, $do_delete_from_playlist);
							else
								ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_add_subscription', '%tr%add_subscription', 550, $do_add_subscription);
						if ($user_data->playlistItem==2)
							if ((HD::has_attribute($user_data, 'itemID'))&&($user_data->itemID==true))
								ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_delete_from_playlist', '%tr%delete_subscription', 550, $do_delete_from_playlist);
							else
								ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_add_subscription', '%tr%add_subscription', 550, $do_add_subscription);
					}
                    return ActionFactory::show_dialog('%tr%actions', $defs,
								true);
				break;
				case 'like_dislike':
				if (!isset($user_input->selected_media_url)){
						if (isset($user_input->plugin_vod_series_ndx)){
						if ($this->allMediaUrl !== null){
						$series_urls = $this->allMediaUrl;
						HD::decode_user_data($series_urls[$user_input->plugin_vod_series_ndx], $media_str, $user_data);
						}
						}else
					return null;
					}
					$defs = array();
					if (HD::has_attribute($user_data, 'video_id'))
                        $VideoId = $user_data->video_id;
					if (HD::has_attribute($user_data, 'episode_ref'))
                        $VideoId = $user_data->episode_ref;
					if (HD::plugin_login($plugin_cookies) == true)
					{
						$jsd = HD::get_authorization_document(HOST_API_URL."/videos/getRating?id=".$VideoId."&key=".API_KEY, &$plugin_cookies);
						if ($jsd['items']['0']['rating']== 'like')
							$q = '%tr%add_a_nonelike1';
						if ($jsd['items']['0']['rating']== 'dislike')
							$$q = '%tr%add_a_nonelike2';
						if ($jsd['items']['0']['rating']== 'none'){
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_like', '%tr%add_a_like', 550, $do_video_like);
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_dislike', '%tr%add_a_dislike', 550, $do_video_dislike);
						}
						else 
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_nonelike', $q, 550, $do_video_nonelike);
						
					}
					else
						ControlFactory::add_label($defs, "", '%tr%dialog_19');
					$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
					return ActionFactory::show_dialog('%tr%actions', $defs,true,0,$attrs);
				break;
				case 'pop_up_menu':
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					$defs = array();
					if (($user_data->playlistItem==0)||(isset($user_data->episode_ref))){
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_related_view', '%tr%show_related_videos', 550, $do_similar_menu);
					if (file_exists('/tmp/yt'))
						$text = '%tr%download_info';
					else
						$text = '%tr%download_yvd';
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_dload_view', $text, 550, $do_dload_menu);
					}
					if ($user_data->playlistItem==1)
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_related_view', '%tr%all_playlists_channel', 550, $do_all_playlist);
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_chanel_view', '%tr%open_video_channel', 550, $do_chanel_view);
					if (HD::plugin_login($plugin_cookies) == true)
					{	if (($user_data->playlistItem==0)||(isset($user_data->episode_ref))){
						if (HD::has_attribute($user_data, 'video_id'))
						$video_id = $user_data->video_id;
						if (HD::has_attribute($user_data, 'episode_ref'))
						$video_id = $user_data->episode_ref;
						$jsd = HD::get_authorization_document(HOST_API_URL."/videos/getRating?id=".$video_id."&key=".API_KEY, &$plugin_cookies);
						if ($jsd['items']['0']['rating']== 'like')
							$q = '%tr%add_a_nonelike1';
						if ($jsd['items']['0']['rating']== 'dislike')
							$$q = '%tr%add_a_nonelike2';
						if ($jsd['items']['0']['rating']== 'none'){
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_like', '%tr%add_a_like', 550, $do_video_like);
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_dislike', '%tr%add_a_dislike', 550, $do_video_dislike);
						}
						else
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_nonelike', $q, 550, $do_video_nonelike);
						
						$jsd_cd = HD::get_authorization_document(HOST_API_URL."/channels?part=contentDetails&maxResults=50&mine=true&key=".API_KEY, &$plugin_cookies);
						$w = $jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['watchLater'];
						$f = $jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['favorites'];
						if (!preg_match("|$w|",$user_input->parent_media_url))
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_watchLater', '%tr%add_a_watchlater', 550, $do_video_watchLater);
						if (!preg_match("|$f|",$user_input->parent_media_url))
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_video_favorites', '%tr%add_a_favorites', 550, $do_video_favorites);
						if ((HD::has_attribute($user_data, 'itemID'))&&($user_data->itemID==true))
							ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_delete_from_playlist', '%tr%delete_from_playlist', 550, $do_delete_from_playlist);
						ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_add_to_playlist', '%tr%add_to_playlist', 550, $do_add_to_playlist);
						ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_add_subscription', '%tr%add_subscription', 550, $do_add_subscription);
						}
						if (($user_data->playlistItem==1)&&(!isset($user_data->episode_ref)))
							if ((HD::has_attribute($user_data, 'itemID'))&&($user_data->itemID==true))
								ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_delete_from_playlist', '%tr%delete_playlist', 550, $do_delete_from_playlist);
							else
								ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_add_subscription', '%tr%add_subscription', 550, $do_add_subscription);
						if ($user_data->playlistItem==2)
							if ((HD::has_attribute($user_data, 'itemID'))&&($user_data->itemID==true))
								ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_delete_from_playlist', '%tr%delete_subscription', 550, $do_delete_from_playlist);
							else
								ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_add_subscription', '%tr%add_subscription', 550, $do_add_subscription);
					}
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'_add_reload', '%tr%add_reload', 550, $do_add_reload);
                    return ActionFactory::show_dialog('%tr%actions', $defs,
								true);
				break;
				case 'reboot':
					shell_exec('reboot');
                    break;
                case 'restart':
                    shell_exec('killall shell');
                    break;
				case 'info_release':
					$post_action = null;
						$doc = HD::http_get_document('http://dune-club.info/plugins/update/'.DuneSystem::$properties['plugin_name'].'/info.txt');
						ControlFactory::add_multiline_label($defs, '', $doc, 15);
						ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'setup', 'Ok', 250,  $post_action);
						return ActionFactory::show_dialog('%tr%information_about_changes', $defs,
								true, 1500);
                    break;
				case 'path_dload':
                    $plugin_cookies->path_dload = $user_input->path_dload;
                    return ActionFactory::reset_controls(
                            $this->do_get_control_defs($plugin_cookies)
                    );
                    break;
				case 'sort_page':
					$defs = array();
					HD::decode_user_data($user_input->parent_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'ser_feed')){
						$current_sort_page = (HD::get_item('sort_page_search', &$plugin_cookies)!=='') ? HD::get_item('sort_page_search', &$plugin_cookies) : 'relevance';
						$current_videoDefinition_page = (HD::get_item('videoDefinition_page', &$plugin_cookies)!=='') ? HD::get_item('videoDefinition_page', &$plugin_cookies) : '&videoDefinition=any';
						$videoDefinition_ops = array();
						$videoDefinition_ops['&videoDefinition=any'] = '%tr%videodefinition_any';
						$videoDefinition_ops['&videoDefinition=high'] = '%tr%videodefinition_high';
						$videoDefinition_ops['&videoDefinition=standard'] = '%tr%videodefinition_standard';
						$this->add_combobox($defs,
							'save_df_page',
							'%tr%videodefinition_video_by',
							$current_videoDefinition_page, $videoDefinition_ops, 600, true
					);	
					}
					else
						$current_sort_page = (HD::get_item('sort_page', &$plugin_cookies)!=='') ? HD::get_item('sort_page', &$plugin_cookies) : 'relevance';
					$show_ops = array();
					$show_ops['date'] = '%tr%date';
					$show_ops['rating'] = '%tr%rating';
					$show_ops['relevance'] = '%tr%relevance';
					$show_ops['title'] = '%tr%title';
					$show_ops['viewCount'] = '%tr%viewcount';
					ControlFactory::add_combobox($defs, $this, null,
						'save_sort_page', '%tr%show_video_by',
						$current_sort_page, $show_ops, 600, $need_confirm = false, $need_apply = false
					);
					$pl_create = (HD::get_item(str_replace(':', '', HD::get_mac_addr()), &$plugin_cookies)!=='') ? HD::get_item(str_replace(':', '', HD::get_mac_addr()), &$plugin_cookies) : 'no';
					$pl_show_ops = array();
					$pl_show_ops['no'] = '%tr%no';
					$pl_show_ops[1] = '%tr%yes_sort_1';
					$pl_show_ops[2] = '%tr%yes_sort_2';
					$pl_show_ops[3] = '%tr%yes_sort_3';
					$this->add_combobox($defs,
							'pl_create_r',
							'%tr%create_a_playlist',
							$pl_create, $pl_show_ops, 600, true
					);
					$skip_details = isset($plugin_cookies->skip_details) ? $plugin_cookies->skip_details : 'no';
					$show_ops = array();
					$show_ops['yes'] = '%tr%yes';
					$show_ops['no'] = '%tr%no';
					$this->add_combobox($defs,
							'skip_details',
							'%tr%skip_description',
							$skip_details, $show_ops, 600, true
					);

					$do_save_sort_page = UserInputHandlerRegistry::create_action($this, 'save_sort_page');
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,
					'_do_save_sort_page', 'OK', 250, $do_save_sort_page);	
                    return ActionFactory::show_dialog(
                            '%tr%select_sort_order',
                            $defs,
								true);
                    break;
				case 'unlogin_page':
				$defs = $this->do_get_unlogin_defs();
					return  ActionFactory::show_dialog
					('%tr%logout_from_youtube_account',
					$defs,
					true);
                    break;
				break;
				case 'unlogin':
				$tokens = HD::get_items('tokens', &$plugin_cookies);
				$doc = HD::http_get_document('https://accounts.google.com/o/oauth2/revoke?token='.$tokens['access_token']);
				$array = array();
				HD::save_items('tokens', $array,&$plugin_cookies);
				return ActionFactory::invalidate_folders(array('main_menu'), null);
                break;
				case 'login_page':
					$defs = array();
					$jsd = json_decode(HD::http_post_document('https://accounts.google.com/o/oauth2/device/code', "client_id=".CLIENT_ID."&scope=https://www.googleapis.com/auth/youtube"), true);
					sleep($jsd['interval']);
					$defs = $this->do_get_login_defs($jsd['device_code'], $jsd['user_code'], $jsd['verification_url'],$jsd['expires_in'], $plugin_cookies);
                    return ActionFactory::show_dialog(
                            '%tr%authorization',
                            $defs,
								true);
                    break;
				case 'login_save':
					$jsd = json_decode(HD::http_post_document('https://accounts.google.com/o/oauth2/token', "client_id=".CLIENT_ID."&client_secret=".CLIENT_SECRET."&code=".$user_input->device_code."&grant_type=http://oauth.net/grant_type/device/1.0"), true);
					if ((isset($jsd['access_token']))&&(isset($jsd['refresh_token'])))
						HD::save_items('tokens', $jsd,&$plugin_cookies);
					if (isset($jsd['error']))
						return ActionFactory::show_title_dialog(strtoupper(str_replace('_', ' ', $jsd['error'])));
                    return ActionFactory::invalidate_folders(array('main_menu'), null);
                    break;
				case 'country_and_localization':
					$defs = array();
					$current_сountry = (HD::get_item('сountry', &$plugin_cookies)!=='') ? HD::get_item('сountry', &$plugin_cookies) : HD::country();
					$current_local = (HD::get_item('local', &$plugin_cookies)!=='') ? HD::get_item('local', &$plugin_cookies) : 'en';
					$search_local = (HD::get_item('search_local', &$plugin_cookies)!=='') ? HD::get_item('search_local', &$plugin_cookies) : 'yes';
					$show_ops = array();
					$show_ops = unserialize(file_get_contents(dirname(__FILE__) . '/data/country_list'));
					ControlFactory::add_combobox($defs, $this, null,
						'save_сountry', '%tr%country',
						$current_сountry, $show_ops, 500, $need_confirm = false, $need_apply = false
					);
					$local_show_ops = array();
					$local_show_ops = unserialize(file_get_contents(dirname(__FILE__) . '/data/local_list'));
					$this->add_combobox($defs,
							'save_local',
							'%tr%localization',
							$current_local, $local_show_ops, 500, $need_confirm = false, $need_apply = false
					);
					$show_ps = array();
					$show_ps['yes'] = '%tr%yes';
					$show_ps['no'] = '%tr%no';
					$this->add_combobox($defs,
							'search_local',
							'%tr%search_local',
							$search_local, $show_ps, 500, $need_confirm = false, $need_apply = false
					);
					$do_save_сountry_and_localization = UserInputHandlerRegistry::create_action($this, 'save_сountry_and_localization');
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,
					'_do_save_сountry_and_localization', 'OK', 250, $do_save_сountry_and_localization);	
                    return ActionFactory::show_dialog(
                            '%tr%c_and_l',
                            $defs,
								true);
                    break;
				case 'save_сountry_and_localization':
                    HD::save_item('сountry', $user_input->save_сountry,&$plugin_cookies);
					HD::save_item('local', $user_input->save_local,&$plugin_cookies);
					HD::save_item('search_local', $user_input->search_local,&$plugin_cookies);
					FolderCache::clear();
                    return ActionFactory::invalidate_folders(array($user_input->parent_media_url), null);
                    break;
				case 'save_sort_page':
					$new_value = $user_input->save_sort_page;
					HD::decode_user_data($user_input->parent_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'ser_feed'))
						HD::save_item('sort_page_search', $new_value,&$plugin_cookies);
					else
						HD::save_item('sort_page', $new_value,&$plugin_cookies);
					FolderCache::clear();
                    return ActionFactory::update_regular_folder(
                                    $this->get_regular_folder_items($user_input->parent_media_url, 0, $plugin_cookies), true);
                    break;
				case 'save_df_page':
					HD::save_item('videoDefinition_page', $user_input->save_df_page,&$plugin_cookies);
					FolderCache::clear();
                    return ActionFactory::update_regular_folder(
                                    $this->get_regular_folder_items($user_input->parent_media_url, 0, $plugin_cookies), true);
                    break;
				case 'add_reload':
					FolderCache::clear();
                    return ActionFactory::update_regular_folder(
                                    $this->get_regular_folder_items($user_input->parent_media_url, 0, $plugin_cookies), true);
                    break;
				case 'setup':
                    return ActionFactory::open_folder('setup');
					break;
                case 'show_main_icon':
                    $new_value = $user_input->{$control_id};
                    $plugin_cookies->main_icon = $new_value;
		            if ($new_value == 'yes')
		            {
			            $plugin_cookies->show_channels_v4 = 'no';
			            $plugin_cookies->show_search_v4 = 'no';
			            $plugin_cookies->show_favorites = 'no';
		            }
		            else
		            {
			            $plugin_cookies->show_channels_v4 = 'yes';
			            $plugin_cookies->show_search_v4 = 'yes';
			            $plugin_cookies->show_favorites = 'yes';
		            }
                    return ActionFactory::reset_controls(
                            $this->do_get_control_defs($plugin_cookies)
                    );
                    break;
                case 'video_quality':
                    $new_value = $user_input->{$control_id};
                    $plugin_cookies->video_quality = $new_value;
                    return ActionFactory::reset_controls(
                            $this->do_get_control_defs($plugin_cookies)
                    );
                    break;
                case 'use_osk':
                    $new_value = $user_input->{$control_id};
                    $plugin_cookies->use_osk = $new_value;
                    return ActionFactory::reset_controls(
                            $this->do_get_control_defs($plugin_cookies)
                    );
                    break;
                case 'skip_details':
                    $new_value = $user_input->{$control_id};
                    $plugin_cookies->skip_details = $new_value;
                    FolderCache::clear();
                    return ActionFactory::update_regular_folder(
                                    $this->get_regular_folder_items($user_input->parent_media_url, 0, $plugin_cookies), true);
                    break;
				case 'show_comment':
                    $new_value = $user_input->show_comment;
                    $plugin_cookies->show_comment = $new_value;
                    return ActionFactory::reset_controls(
                            $this->do_get_control_defs($plugin_cookies)
                    );
                    break;
				// case 'pl_create':
                    // HD::save_item(str_replace(':', '', HD::get_mac_addr()), $user_input->pl_create, &$plugin_cookies);
                    // return ActionFactory::reset_controls(
                            // $this->do_get_control_defs($plugin_cookies)
                    // );
                    // break;
				case 'pl_create_r':
                    HD::save_item(str_replace(':', '', HD::get_mac_addr()), $user_input->pl_create_r, &$plugin_cookies);
					return null;
                    break;
                case 'buf_time':
                    $new_value = $user_input->{$control_id};
                    $plugin_cookies->buf_time = $new_value;
                    return  ActionFactory::reset_controls
                            (
                                $this->do_get_control_defs($plugin_cookies)
                            );
                    break;
                case 'ex_view_info':
                    if (!isset($user_input->selected_media_url))
                        return null;
					if (HD::has_attribute($user_input, 'parent_media_url'))
			            if ($user_input->parent_media_url=='main_menu:fav')
							$this->oMediaUrl = null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    
                    if (!HD::has_attribute($user_data, 'video_id'))
                        return null;
                    if ($user_data->playlistItem==2)
                       return array
                        (
                             GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                             GuiAction::data => array(
                                    'media_url' => HD::encode_user_data(
                                                        array(
                                                            'channelId' => $user_data->video_id,
                                                        )
                                                    )
                             )
                         );
					 
                    return array
                        (
                             GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                             GuiAction::data => array(
                                    'media_url' => HD::encode_user_data(
                                                        array(
                                                            'info' => '1',
                                                            'video_id' => $user_data->video_id,
                                                            'season_ref' => $user_data->video_id,
															'playlistItem' => $user_data->playlistItem,
															'season_title' => $user_data->season_title,
															'season_image' => $user_data->season_image,
															'authorize' => $user_data->authorize,
															'itemID' => $user_data->itemID,
															'season_channel' => $user_data->season_channel,
                                                        )
                                                    )
                             )
                         );
                    break;
                    
                case 'add_fav_complite':
				if (HD::plugin_login($plugin_cookies) == true)
					return UserInputHandlerRegistry::create_action($this, 'video_favorites');
				else
                    return ActionFactory::show_title_dialog(
                        (
                            '%tr%video_has_been_added_to_favorites'
                        )
                    );
                    break;
                 case 'del_fav_complite':
                    return ActionFactory::show_title_dialog(
                        (
                            '%tr%video_has_been_deleted_from_favorites'
                        )
                    );
                    break;  
                case 'add_favorite':
					$qq = false;
                    if (isset($user_input->selected_media_url)){
                    if ($user_input->selected_media_url === 'right_button')
                        HD::decode_user_data($user_input->parent_media_url, $media_str, $user_data);
                    else
                        HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					}
					if (!isset($user_input->selected_media_url)){
						if (isset($user_input->plugin_vod_series_ndx)){
						if ($this->allMediaUrl !== null){
						$series_urls = $this->allMediaUrl;
						HD::decode_user_data($series_urls[$user_input->plugin_vod_series_ndx], $media_str, $user_data);
						$qq = true;
						}
						}else
					return null;
					}
					if (HD::has_attribute($user_data, 'video_id')){
                    	$video_id = $user_data->video_id;
						$image = $user_data->season_image;
						$title = $user_data->season_title;
						$playlistItem = $user_data->playlistItem;
					}
					else if (HD::has_attribute($user_data, 'episode_ref')){
                    	$video_id = $user_data->episode_ref;
						$image = $user_data->poster_url;
						$title = $user_data->episode_title;
						$playlistItem = $user_data->playlistItem;
					}
					else
                        return null;
					$fav_items = HD::get_items('fav_items', &$plugin_cookies);
                    if (!in_array($video_id, $fav_items))
                    {
						array_unshift($fav_items, $video_id); 
						HD::save_items('fav_items', $fav_items,&$plugin_cookies);
						$links = array();
						$links['img'] = $image;
						$links['title'] = $title;
						$links['playlistItem'] = $playlistItem;
						$fav_links = HD::get_items('fav_items_link', &$plugin_cookies);	
						$fav_links[$video_id] = $links;
						HD::save_items('fav_items_link', $fav_links, &$plugin_cookies);
						if ($qq == true){
							$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
							return ActionFactory::show_title_dialog('%tr%video_has_been_added_to_favorites',null,$attrs);
						}
						if ($user_input->selected_media_url === 'right_button')
                            return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $add_fav_complite);
                        else
                            return ActionFactory::invalidate_folders(array('main_menu:fav'), $add_fav_complite);
                    }
                    else{
						$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
                        return ActionFactory::show_title_dialog('%tr%video_is_already_in_favorites',null,$attrs);
					}
                    break;
                case 'remove_fav':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    if ($user_input->selected_media_url === 'right_button')
                        HD::decode_user_data($user_input->parent_media_url, $media_str, $user_data);
                    else
                        HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);

                    if (HD::has_attribute($user_data, 'video_id'))
                        $video_id = $user_data->video_id;
                    else if (HD::has_attribute($user_data, 'fav'))
                        $video_id = $user_data->fav;
                    else
                        return null;
					$fav_items = HD::get_items('fav_items', &$plugin_cookies);
					$k = array_search($video_id, $fav_items);
					unset ($fav_items [$k]);
					$fav_items = array_values($fav_items);
					HD::save_items('fav_items', $fav_items,&$plugin_cookies);
					$fav_links = HD::get_items('fav_items_link', &$plugin_cookies);	
                    if (isset($fav_links[$video_id]))
                        unset($fav_links[$video_id]);
					HD::save_items('fav_items_link', $fav_links,&$plugin_cookies);
                    $folder = FolderCache::get('main_menu:fav');
                    $folder->set_expired();
                    return ActionFactory::invalidate_folders(array($user_input->parent_media_url), $del_fav_complite);
                    break;
                case 'move_fav_top':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    $video_id = $user_data->video_id;
					$fav_items = HD::get_items('fav_items', &$plugin_cookies);
					$k = array_search($video_id, $fav_items);
					unset ($fav_items [$k]);
					array_unshift($fav_items, $video_id);
					HD::save_items('fav_items', $fav_items,&$plugin_cookies);
                    FolderCache::clear();
                    return ActionFactory::invalidate_folders(array($user_input->parent_media_url), null);
                    break;
				case 'move_mm_top':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    $mm = $user_input->selected_media_url;
					$items = unserialize(file_get_contents(DuneSystem::$properties['install_dir_path'].'/data/mm'));
					foreach ($items as $key => $value){
					if ($value['media_url']==$mm){
						$id = $items [$key];
					unset ($items [$key]);
					array_unshift($items, $id);
					}}
					$skey = serialize($items);
					$data = fopen(DuneSystem::$properties['install_dir_path'].'/data/mm',"w");
						if (!$data)
							return ActionFactory::show_title_dialog("Не могу записать items Что-то здесь не так!!!");

						fwrite($data, $skey);
						@fclose($data);
                    FolderCache::clear();
                    return ActionFactory::invalidate_folders(array($user_input->parent_media_url), null);
                    break;
				case 'move_fav_top_one':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    $video_id = $user_data->video_id;
					$fav_items = HD::get_items('fav_items', &$plugin_cookies);
					$k = array_search($video_id, $fav_items);
					if ($k !== false && $k !== 0)
					{
					$t = $fav_items[$k - 1];
					$fav_items[$k - 1] = $fav_items[$k];
					$fav_items[$k] = $t;
					}
					HD::save_items('fav_items', $fav_items,&$plugin_cookies);
                    FolderCache::clear();
                    return ActionFactory::invalidate_folders(array($user_input->parent_media_url), null);
                    break;
				case 'move_fav_low_one':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    $video_id = $user_data->video_id;
					$fav_items = HD::get_items('fav_items', &$plugin_cookies);
					$k = array_search($video_id, $fav_items);
					if ($k !== false && $k !== count($fav_items) - 1)
					{
					$t = $fav_items[$k + 1];
					$fav_items[$k + 1] = $fav_items[$k];
					$fav_items[$k] = $t;
					}
					HD::save_items('fav_items', $fav_items,&$plugin_cookies);
                    FolderCache::clear();
                    return ActionFactory::invalidate_folders(array($user_input->parent_media_url), null);
                    break;
                case 'just_play':
                    return array(
                            GuiAction::handler_string_id => PLUGIN_VOD_PLAY_ACTION_ID,
                            GuiAction::data =>
                                array(
                                    'media_url' => $user_input->selected_media_url
                                )
                    );
                    break;
                case 'play_item':
                    if (!isset($user_input->selected_media_url))
                        return null;

                    return ActionFactory::invalidate_folders(array($user_input->selected_media_url, $user_input->parent_media_url), $just_play);
                    break;
		        case 'view_series':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_input, 'parent_media_url'))
			            if ($user_input->parent_media_url=='main_menu:fav')
							$this->oMediaUrl = null;
					if (HD::has_attribute($user_data, 'playlistItem'))
			            if ($user_data->playlistItem==2)
							return array
                        (
                             GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                             GuiAction::data => array(
                                    'media_url' => HD::encode_user_data(
                                                        array(
                                                            'channelId' => $user_data->video_id,
                                                        )
                                                    )
                             )
                        );
		            $n_series = 0;
		            if (HD::has_attribute($user_data, 'n_series'))
			            $n_series = $user_data->n_series;
	
		            $ndx_series = -1;
		            if (HD::has_attribute($user_data, 'ndx_series'))
			            $ndx_series = $user_data->ndx_series;

		            if ($n_series < 2 || $ndx_series >= 0)
		            {
	                    return array(
        	                GuiAction::handler_string_id => PLUGIN_VOD_PLAY_ACTION_ID,
                	        GuiAction::data =>
                        	array(
	                            'media_url' => $user_input->selected_media_url
        	                )
			            );
		            }
		            else
		            {
	                    return array(
        	                GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                	        GuiAction::data =>
                        	array(
	                            'media_url' => $user_input->selected_media_url
        	                )
			            );
                   }
		           break;
                case 'remove_search':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    $ser_feed = urldecode($user_data->ser_feed);
                    $search_items = HD::get_items('search_items', &$plugin_cookies);
					$k = array_search($ser_feed, $search_items);
					unset ($search_items [$k]);
					HD::save_items('search_items', $search_items,&$plugin_cookies);
                    return ActionFactory::update_regular_folder(
                                    $this->get_regular_folder_items('main_menu:search', 0, $plugin_cookies), true);
                    break;
				case 'chanel_view':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'season_channel'))
                        $channelId = $user_data->season_channel;
					else if (HD::has_attribute($user_data, 'channelTitle')){
						$jsd = json_decode(HD::http_get_document(HOST_API_URL."/channels?part=snippet&forUsername=".$user_data->channelTitle."&key=".API_KEY), true);
						$channelId = $jsd['items']['0']['id'];
					}
					
					return array
                        (
                             GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                             GuiAction::data => array(
                                    'media_url' => HD::encode_user_data(
                                                        array(
                                                            'channelId' => $channelId,
                                                        )
                                                    )
                             )
                         );
                    break;
				case 'related_view':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'video_id'))
                        $relatedToVideoId = $user_data->video_id;
					if (HD::has_attribute($user_data, 'episode_ref'))
                        $relatedToVideoId = $user_data->episode_ref;
					return array
                        (
                             GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                             GuiAction::data => array(
                                    'media_url' => HD::encode_user_data(
                                                        array('subcategory_ref' => HOST_API_URL."/search?relatedToVideoId=".$relatedToVideoId."&part=snippet&type=video&maxResults=50&key=".API_KEY."&pageToken=",)
                                                    )
                             )
                         );
                    break;
				case 'comment':
					if (!isset($user_input->selected_media_url)){
						if (isset($user_input->plugin_vod_series_ndx)){
						if ($this->allMediaUrl !== null){
						$series_urls = $this->allMediaUrl;
						HD::decode_user_data($series_urls[$user_input->plugin_vod_series_ndx], $media_str, $user_data);
						}
						}else
					return null;
					}
					if (HD::has_attribute($user_data, 'video_id'))
                        $VideoId = $user_data->video_id;
					if (HD::has_attribute($user_data, 'episode_ref'))
                        $VideoId = $user_data->episode_ref;
					$nextPageToken = false;
					if (HD::has_attribute($user_input, 'nextPageToken'))
						$nextPageToken = $user_input->nextPageToken;
					$jsd = json_decode(HD::http_get_document(HOST_API_URL."/commentThreads?part=snippet&maxResults=20&order=relevance&pageToken=$nextPageToken&textFormat=plainText&videoId=$VideoId&key=".API_KEY), true);
					$doc = '';
					$nextPageToken = false;
					if (isset($jsd['nextPageToken']))
					$nextPageToken = $jsd['nextPageToken'];
					if (!isset($jsd['items']))
						ControlFactory::add_label($defs, "", '%tr%dialog_20');
					else{
					foreach ($jsd['items'] as $value)
					$doc .= "\n[". $value['snippet']['topLevelComment']['snippet']['authorDisplayName'].']: '. str_replace("\n", '', $value['snippet']['topLevelComment']['snippet']['textDisplay']);
					ControlFactory::add_multiline_label($defs, '', $doc, 15);
					}
					if ($nextPageToken==true){
					$add_params ['nextPageToken'] = $nextPageToken;
					ControlFactory::add_button_close(&$defs, $this, $add_params, 'comment', '', 'Next', 0);
					}
					$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
						return  ActionFactory::show_dialog('%tr%comments',$defs,true,1500,$attrs);
					
					break;
				case 'dload':
                    $defs = array();
					if (!file_exists('/codecpack/script/youtube_download.sh')){
					ControlFactory::add_multiline_label($defs, '', '%tr%dialog_13', 8);
					$do_new_install_action = UserInputHandlerRegistry::create_action($this, 'do_new_install');
					ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'apply_subscription','%tr%install_codecs',500, $do_new_install_action);
					ControlFactory::add_close_dialog_button($defs,'%tr%cancel', 500);
					$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
					return ActionFactory::show_dialog('%tr%dialog_12',$defs, true, 1200,$attrs);
					}
					if (file_exists('/tmp/yt')){
						$lines = file('/tmp/yt', FILE_SKIP_EMPTY_LINES);
						$line = array_pop ($lines);
						if (preg_match('|0K|', $line))
						$line= str_replace(' ..........', '',$lines[count($lines)-1]);
						ControlFactory::add_label($defs, '%tr%performed', $line);
						ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'dload_stop',
								'%tr%stop_download',
								500, UserInputHandlerRegistry::create_action($this, 'dload_stop'));
						$attrs['timer'] = ActionFactory::timer(3000);
						$attrs['actions'] = array(GUI_EVENT_TIMER => ActionFactory::close_dialog_and_run($do_dload_menu));
						$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
						return  ActionFactory::show_dialog('%tr%download_added',$defs,true, $preferred_width = 0,$attrs);
					}
					else 
					{
					if (!isset($user_input->selected_media_url)){
						if (isset($user_input->plugin_vod_series_ndx)){
						if ($this->allMediaUrl !== null){
						$series_urls = $this->allMediaUrl;
						HD::decode_user_data($series_urls[$user_input->plugin_vod_series_ndx], $media_str, $user_data);
						}
						}else
					return null;
					}
					else
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'video_id'))
                        $VideoId = $user_data->video_id;
					if (HD::has_attribute($user_data, 'episode_ref'))
                        $VideoId = $user_data->episode_ref;
					$media_urls = Youtube::retrieve_playback_url($VideoId, 1, $plugin_cookies);
					
					foreach ($media_urls as $key => $value){
					$text = str_replace(array('18','22','139','140','141','137','299'),array('Video medium (640x360)','Video hd720 (1280x720)','Audio (m4a)','Audio (m4a)','Audio (m4a)','Video hd1080 (1920x1080)','Video hd1080 (1920x1080)'),$key);
					if (($key == 18)||($key == 22))
						$add_params['dload_url'] = $value;
					if (($key == 139)||($key == 140)||($key == 141))
						$add_params['a_dload_url'] = $value;
					if (($key == 137)||($key == 299)){
						$add_params['video_dload_url'] = $value;
						if (isset($media_urls['139']))
							$add_params['audio_dload_url'] = $media_urls['139'];
						if (isset($media_urls['140']))
							$add_params['audio_dload_url'] = $media_urls['140'];
						if (isset($media_urls['141']))
							$add_params['audio_dload_url'] = $media_urls['141'];
					}
					ControlFactory::add_button_close(&$defs,$this, $add_params, 'new_dload_conf', '', $text, 600);
					$add_params = array();
					}
					$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
					return ActionFactory::show_dialog('%tr%download_yvd', $defs, true, 0 ,$attrs);
					}
                    break;
				case 'dload_stop':
				shell_exec ("/codecpack/script/youtube_download.sh --stop");
				return ActionFactory::show_title_dialog('%tr%dload_stop'); 
				break;

				case 'do_new_install':
				$add_params = array('name' => 'Codec_install');
                    $url = 'plugin_installer://http://dune-club.info/plugins/update/Codec_install/dune_plugin_Codec_install_v3.1.tar.gz:::name=Codec_install&space_needed=2000000&need_confirm_replace=0';
					return ActionFactory::launch_media_url($url,UserInputHandlerRegistry::create_action($this, 'add_reload', $add_params));
				break;
				case 'new_dload_conf':
				if (!isset($user_input->selected_media_url)){
						if (isset($user_input->plugin_vod_series_ndx)){
							if ($this->allMediaUrl !== null){
								$series_urls = $this->allMediaUrl;
						HD::decode_user_data($series_urls[$user_input->plugin_vod_series_ndx], $media_str, $user_data);
						}
						}else
					return null;
					}
				else
					HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					$title = '';
                    if (HD::has_attribute($user_data, 'episode_title'))
                        $title = str_replace(array("/","|","\\", "?", ":", ";","\*","<",">"), '',$user_data->episode_title);
                    else if (HD::has_attribute($user_data, 'season_title'))
                        $title = str_replace(array("/","|","\\", "?", ":", ";","\*","<",">"), '',$user_data->season_title);
				
				$d_path = HD::get_dload_path(&$plugin_cookies);
				$download_dir = $d_path.'/'.$title;
				if (isset($user_input->dload_url))
					shell_exec ("/codecpack/script/youtube_download.sh --start_mp4 \"$title\" \"$d_path\" \"".$user_input->dload_url."\" \"$d_path\" > /dev/null &");
				if ((isset($user_input->video_dload_url))&&(isset($user_input->audio_dload_url)))
					shell_exec ("/codecpack/script/youtube_download.sh --start_dash \"$title\" \"$d_path\" \"".$user_input->audio_dload_url."\" \"".$user_input->video_dload_url."\" > /dev/null &");
				if (isset($user_input->a_dload_url))
					shell_exec ("/codecpack/script/youtube_download.sh --start_audio \"$title\" \"$d_path\" \"".$user_input->a_dload_url."\" \"$d_path\" > /dev/null &");
				$defs = array();
				ControlFactory::add_label($defs, "", '%tr%dialog_8');
				ControlFactory::add_label($defs, "", '%tr%dialog_9');
				ControlFactory::add_label($defs, "", '%tr%dialog_10');
				ControlFactory::add_close_dialog_button($defs, 'OK', 250);
				$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
				return  ActionFactory::show_dialog('%tr%download_added',$defs,true,0,$attrs);
				break;
				case 'all_playlist':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'season_channel'))
                        $season_channel = $user_data->season_channel;
					return array
                        (
                             GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                             GuiAction::data => array(
                                    'media_url' => HD::encode_user_data(
                                                        array('subcategory_ref' => HOST_API_URL."/playlists?part=snippet&channelId=".$season_channel."&maxResults=50&key=".API_KEY."&pageToken=",)
                                                    )
                             )
                         );
                    break;	
				case 'video_like':
                    if (!isset($user_input->selected_media_url)){
						if (isset($user_input->plugin_vod_series_ndx)){
						if ($this->allMediaUrl !== null){
						$series_urls = $this->allMediaUrl;
						HD::decode_user_data($series_urls[$user_input->plugin_vod_series_ndx], $media_str, $user_data);
						}
						}else
					return null;
					}
					else
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'video_id'))
						$video_id = $user_data->video_id;
					if (HD::has_attribute($user_data, 'episode_ref'))
						$video_id = $user_data->episode_ref;
					$g = HD::get_authorization_document(HOST_API_URL."/videos/rate?id=".$video_id."&rating=like&key=".API_KEY, &$plugin_cookies, HD::encode_user_data(array('id' => $user_data->video_id, 'rating' => 'like')));
                    return null;
					break;
				case 'video_dislike':
                    if (!isset($user_input->selected_media_url)){
						if (isset($user_input->plugin_vod_series_ndx)){
						if ($this->allMediaUrl !== null){
						$series_urls = $this->allMediaUrl;
						HD::decode_user_data($series_urls[$user_input->plugin_vod_series_ndx], $media_str, $user_data);
						}
						}else
					return null;
					}
					else
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'video_id'))
						$video_id = $user_data->video_id;
						if (HD::has_attribute($user_data, 'episode_ref'))
						$video_id = $user_data->episode_ref;
					HD::get_authorization_document(HOST_API_URL."/videos/rate?id=".$video_id."&rating=dislike&key=".API_KEY, &$plugin_cookies, HD::encode_user_data(array('id' => $user_data->video_id, 'rating' => 'dislike')));
                    return null;
					break;
				case 'video_nonelike':
                    if (!isset($user_input->selected_media_url)){
						if (isset($user_input->plugin_vod_series_ndx)){
						if ($this->allMediaUrl !== null){
						$series_urls = $this->allMediaUrl;
						HD::decode_user_data($series_urls[$user_input->plugin_vod_series_ndx], $media_str, $user_data);
						}
						}else
					return null;
					}
					else
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'video_id'))
						$video_id = $user_data->video_id;
						if (HD::has_attribute($user_data, 'episode_ref'))
						$video_id = $user_data->episode_ref;
					HD::get_authorization_document(HOST_API_URL."/videos/rate?id=".$video_id."&rating=none&key=".API_KEY, &$plugin_cookies, HD::encode_user_data(array('id' => $user_data->video_id, 'rating' => 'none')));
                    return null;
					break;
				case 'video_watchLater':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'video_id'))
						$video_id = $user_data->video_id;
						if (HD::has_attribute($user_data, 'episode_ref'))
						$video_id = $user_data->episode_ref;
						$jsd_cd = HD::get_authorization_document(HOST_API_URL."/channels?part=contentDetails&maxResults=50&mine=true&key=".API_KEY, &$plugin_cookies);
					HD::get_authorization_document(HOST_API_URL."/playlistItems?part=snippet&key=".API_KEY, &$plugin_cookies, '{"snippet":{"playlistId": "'.$jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['watchLater'].'","resourceId":{"kind": "youtube#video","videoId": "'.$video_id.'"}}}');
					return null;
					break;
				case 'video_favorites':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'video_id'))
						$video_id = $user_data->video_id;
						if (HD::has_attribute($user_data, 'episode_ref'))
						$video_id = $user_data->episode_ref;
						$jsd_cd = HD::get_authorization_document(HOST_API_URL."/channels?part=contentDetails&maxResults=50&mine=true&key=".API_KEY, &$plugin_cookies);
					HD::get_authorization_document(HOST_API_URL."/playlistItems?part=snippet&key=".API_KEY, &$plugin_cookies, '{"snippet":{"playlistId": "'.$jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['favorites'].'","resourceId":{"kind": "youtube#video","videoId": "'.$video_id.'"}}}');
					return ActionFactory::show_title_dialog('%tr%video_has_been_added_to_favorites');
					break;
				case 'add_subscription':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'season_channel'))
						$channelId = $user_data->season_channel;
					HD::get_authorization_document(HOST_API_URL."/subscriptions?part=snippet&key=".API_KEY, &$plugin_cookies, '{"snippet":{"resourceId":{"channelId": "'.$channelId.'"}}}');
					$add_subscription_complite = UserInputHandlerRegistry::create_action($this, 'add_subscription_complite');
					FolderCache::clear();
					return ActionFactory::invalidate_folders(array('main_menu:subscription'), $add_subscription_complite);
					break;
				case 'add_subscription_complite':
                    return ActionFactory::show_title_dialog('%tr%subscription_added');
                    break;
				case 'add_to_playlist':
                    $defs = $this->do_get_add_mypl_defs($plugin_cookies, $this);
					$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
					return  ActionFactory::show_dialog('%tr%add_to_playlist',$defs,true,0,$attrs);
					break;
				case 'apply_new_mypl':
					$attrs['dialog_params'] = array('frame_style' => DIALOG_FRAME_STYLE_GLASS);
                    if (!isset($user_input->selected_media_url)){
						if (isset($user_input->plugin_vod_series_ndx)){
						if ($this->allMediaUrl !== null){
						$series_urls = $this->allMediaUrl;
						HD::decode_user_data($series_urls[$user_input->plugin_vod_series_ndx], $media_str, $user_data);
						}
						}else
					return null;
					}
					else
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'video_id'))
						$video_id = $user_data->video_id;
					if (HD::has_attribute($user_data, 'episode_ref'))
						$video_id = $user_data->episode_ref;
					if (($user_input->mypl_names)!= '0')
					HD::get_authorization_document(HOST_API_URL."/playlistItems?part=snippet&key=".API_KEY, &$plugin_cookies, '{"snippet":{"playlistId": "'.$user_input->mypl_names.'","resourceId":{"kind": "youtube#video","videoId": "'.$video_id.'"}}}');
					else if (($user_input->mypl_name)!== ''){
						$jsd = HD::get_authorization_document(HOST_API_URL."/playlists?part=snippet%2Cstatus&key=".API_KEY, &$plugin_cookies, '{"snippet": {"title": "'.$user_input->mypl_name.'","description":"Created on Dune HD"},"status":{"privacyStatus":"private"}}');
						HD::get_authorization_document(HOST_API_URL."/playlistItems?part=snippet&key=".API_KEY, &$plugin_cookies, '{"snippet":{"playlistId": "'.$jsd['id'].'","resourceId":{"kind": "youtube#video","videoId": "'.$video_id.'"}}}');
					}
					else
					return ActionFactory::show_title_dialog('%tr%playlist_not_specified',null,$attrs);
					return ActionFactory::show_title_dialog('%tr%added_to_playlist',null,$attrs);
					break;
				case 'delete_from_playlist':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
					if (HD::has_attribute($user_data, 'itemID')){
						if ($user_data->playlistItem==1)
							HD::get_authorization_document(HOST_API_URL."/playlists?id=".$user_data->itemID."&key=".API_KEY, &$plugin_cookies, 'delete');
						else if ($user_data->playlistItem==2){
							HD::get_authorization_document(HOST_API_URL."/subscriptions?id=".$user_data->itemID."&key=".API_KEY, &$plugin_cookies, 'delete');
							FolderCache::clear();
							sleep (10);
						}
						else
							HD::get_authorization_document(HOST_API_URL."/playlistItems?id=".$user_data->itemID."&key=".API_KEY, &$plugin_cookies, 'delete');
					}
					FolderCache::clear();
                    return ActionFactory::update_regular_folder(
                                    $this->get_regular_folder_items($user_input->parent_media_url, 0, $plugin_cookies), true);
					break;
				case 'search_playlist':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    return array
                    (
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                        GuiAction::data =>
                        array
                        (
                            'media_url' => HD::encode_user_data(array('ser_feed' => $user_data->ser_feed, 'ser_link' => 'playlist'))
                        )
                    );
                    break;
				case 'search_channel':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    return array
                    (
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                        GuiAction::data =>
                        array
                        (
                            'media_url' => HD::encode_user_data(array('ser_feed' => $user_data->ser_feed, 'ser_link' => 'channel'))
                        )
                    );
                    break;
				case 'search_all':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    return array
                    (
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                        GuiAction::data =>
                        array
                        (
                            'media_url' => HD::encode_user_data(array('ser_feed' => $user_data->ser_feed, 'ser_link' => 'video,channel,playlist'))
                        )
                    );
                    break;
				case 'move_search_top_one':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    $ser_feed = urldecode($user_data->ser_feed);
                    $search_items = HD::get_items('search_items', &$plugin_cookies);
					$k = array_search($ser_feed, $search_items);
					if ($k !== false && $k !== 0)
					{
					$t = $search_items[$k - 1];
					$search_items[$k - 1] = $search_items[$k];
					$search_items[$k] = $t;
					}
					HD::save_items('search_items', $search_items,&$plugin_cookies);
                    return ActionFactory::update_regular_folder(
                                    $this->get_regular_folder_items('main_menu:search', 0, $plugin_cookies), true);
                    break;
				case 'move_search_low_one':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    $ser_feed = urldecode($user_data->ser_feed);
                    $search_items = HD::get_items('search_items', &$plugin_cookies);
					$k = array_search($ser_feed, $search_items);
					if ($k !== false && $k !== count($search_items) - 1)
					{
					$t = $search_items[$k + 1];
					$search_items[$k + 1] = $search_items[$k];
					$search_items[$k] = $t;
					}
					HD::save_items('search_items', $search_items,&$plugin_cookies);
                    return ActionFactory::update_regular_folder(
                                    $this->get_regular_folder_items('main_menu:search', 0, $plugin_cookies), true);
                    break;
                case 'move_search_top':
                    if (!isset($user_input->selected_media_url))
                        return null;
                    HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                    $ser_feed = urldecode($user_data->ser_feed);
                    $search_items = HD::get_items('search_items', &$plugin_cookies);
					$k = array_search($ser_feed, $search_items);
					unset ($search_items [$k]);
					array_unshift($search_items, $ser_feed);
					HD::save_items('search_items', $search_items,&$plugin_cookies);
                    return ActionFactory::update_regular_folder(
                                    $this->get_regular_folder_items('main_menu:search', 0, $plugin_cookies), true);
                    break;
                case 'mark_viewed':

                    if (isset($user_input->selected_media_url))
                    {
                        HD::decode_user_data($user_input->selected_media_url, $media_str, $user_data);
                        if (HD::has_attribute($user_data, 'video_id'))
                            $video_id = $user_data->video_id;
                        else if (HD::has_attribute($user_data, 'season_ref'))
                            $video_id = $user_data->season_ref;
                        if (ListUtil::is_in_list($plugin_cookies->fav_items, $video_id))
                        {
                            if (isset($plugin_cookies->$video_id))
                            {
                                if (HD::has_attribute($user_data, 'url_series'))
                                    $url = $user_data->url_series;
                                else if (HD::has_attribute($user_data, 'episode_ref'))
                                    $url = $user_data->episode_ref;
                                if (!ListUtil::is_in_list($plugin_cookies->$video_id, $url))
                                {
                                    $viewed = $plugin_cookies->$video_id;
                                    $plugin_cookies->$video_id = ListUtil::add_item($viewed,$url);
                                }
                            }
                        }
                    }
                    return ActionFactory::update_regular_folder(
                                    $this->get_regular_folder_items($user_input->parent_media_url, 0, $plugin_cookies), true);
                    break;
            }
        }
       
        return array
            (
            GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
            GuiAction::data => array(
                'media_url' => $user_input->selected_media_url
                    )
             );
    }
    ///////////////////////////////////////////////////////////////////////


    protected function add_text_field(&$defs, $name, $title, $initial_value, $numeric, $password, $has_osk, $always_active, $width, $need_confirm = false, $need_apply = false) {
        ControlFactory::add_text_field($defs, $this, null,
                        $name, $title, $initial_value,
                        $numeric, $password, $has_osk, $always_active, $width,
                        $need_confirm, $need_apply);
    }

    ///////////////////////////////////////////////////////////////////////
    protected function add_combobox(&$defs, $name, $title, $initial_value, $value_caption_pairs, $width, $need_confirm = false, $need_apply = false)
    {
        ControlFactory::add_combobox($defs, $this, null,
                        $name, $title, $initial_value, $value_caption_pairs, $width,
                        $need_confirm, $need_apply);
    }

    protected function add_button(&$defs,$name, $title, $caption, $width)
    {
        ControlFactory::add_button($defs, $this, null,
            $name, $title, $caption, $width);
    }

    ///////////////////////////////////////////////////////////////////////
    public function do_get_control_defs(&$plugin_cookies)
    {
        $defs = array();

        $main_icon = isset($plugin_cookies->main_icon) ? $plugin_cookies->main_icon : 'yes';
        $use_osk = isset($plugin_cookies->use_osk) ? $plugin_cookies->use_osk : 'yes';
		$show_comment = isset($plugin_cookies->show_comment) ? $plugin_cookies->show_comment : 'yes';
		$use_marked = (HD::get_item('use_marked', &$plugin_cookies)!=='') ? HD::get_item('use_marked', &$plugin_cookies) : 'no';
		$pl_create = (HD::get_item(str_replace(':', '', HD::get_mac_addr()), &$plugin_cookies)!=='') ? HD::get_item(str_replace(':', '', HD::get_mac_addr()), &$plugin_cookies) : 'no';
        $video_quality = isset($plugin_cookies->video_quality) ? $plugin_cookies->video_quality : 1;
        $buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
		$data_type = isset($plugin_cookies->data_type) ? $plugin_cookies->data_type : '1';
		$data_dir = isset($plugin_cookies->data_dir) ? $plugin_cookies->data_dir : '/';
		$path_dload = isset($plugin_cookies->path_dload) ? $plugin_cookies->path_dload : '/D';
		$dload_dir = isset($plugin_cookies->dload_dir) ? $plugin_cookies->dload_dir : '/';
        $vquality = array();
        $vquality[0] = '%tr%smallest_possible';
        $vquality[1] = '360';
        $vquality[2] = '480';
        $vquality[3] = '720';
        $vquality[4] = '%tr%maximum_possible';
        
		$ver = self::ver();
		
        $show_ops = array();
        $show_ops['yes'] = '%tr%yes';
        $show_ops['no'] = '%tr%no';
        
        $this->add_button
        (
            $defs,
            'info_release',
            "$ver",
            '%tr%information_about_changes',
            0
        );

        $this->add_combobox($defs,
                'video_quality',
                '%tr%video_quality',
                $video_quality, $vquality, 0, true
        );
        
	    $this->add_combobox($defs,
        	    'use_osk',
                '%tr%use_the_onscreen_keyboard_to_search',
                $use_osk, $show_ops, 0, true
            );
		
		$this->add_combobox($defs,
                'show_comment',
                '%tr%comments_show',
                $show_comment, $show_ops, 0, true
        );
        $show_buf_time_ops = array();
        $show_buf_time_ops[0] = '%tr%by_default';
        $show_buf_time_ops[500] = '0.5 с';
        $show_buf_time_ops[1000] = '1 с';
        $show_buf_time_ops[2000] = '2 с';
        $show_buf_time_ops[3000] = '3 с';
        $show_buf_time_ops[5000] = '5 с';
        $show_buf_time_ops[10000] = '10 с';

        $this->add_combobox
        (
            $defs,
            'buf_time',
            '%tr%buffer_time',
            $buf_time, $show_buf_time_ops, 0, true
        );
		
		$data_ops = array();
		$data_ops[1] = '%tr%plugin';
        $data_ops['/D'] = '%tr%the_first_hdd_usb_drive';
		$data_ops[2] = '%tr%smb_folder';
		foreach (glob('/tmp/mnt/storage/*') as $file) 
    		if (is_dir($file)) $data_ops[$file] = ' -'.substr($file,17,strlen($file));
		$this->add_combobox($defs,
            'data_type', '%tr%location_data',
            $data_type, $data_ops, 0, true);

		if (($data_type != '1')&&($data_type != '2')) {
			$data_dir_ops = array();
			$data_dir_ops["$data_type"] = '/';
			foreach (glob("$data_type/*") as $file)
			if (is_dir($file)) {
			if (preg_match('|/tmp/mnt/|', $file))
				$file	= basename($file);
			else
				$file	= substr($file,3,strlen($file));
			$data_dir_ops['/'.$file] = $file;
			}
			$this->add_combobox($defs,
					'data_dir', '%tr%catalogue',
					$data_dir, $data_dir_ops, 0, true);
		}
		if ($data_type == 2) {
		 $this->add_button($defs,
            'data_path_smb',
            '%tr%the_path_username_and_password_smb',
            '%tr%amend',
            500
        );	
		}
		if ($data_type == 1) {
		$this->add_button($defs,
            'export_data',
            '%tr%folder_data_to_d',
            '%tr%upload_download',
            400
        );
		}
		$dload_ops = array();
        $dload_ops['/D'] = '%tr%the_first_hdd_usb_drive';
		$dload_ops[1] = '%tr%smb_folder';
		foreach (glob('/tmp/mnt/storage/*') as $file) 
    		if (is_dir($file)) $dload_ops[$file] = ' -'.substr($file,17,strlen($file));
			
		$this->add_combobox($defs,
            'path_dload', '%tr%path_to_folder_upload',
            $path_dload, $dload_ops, 0, true);
			
		if ($path_dload != '1'){
			$dload_dir_ops = array();
			$dload_dir_ops[""] = '/';
			foreach (glob("$path_dload/*") as $file)
			if (is_dir($file)) {
			if (preg_match('|/tmp/mnt/|', $file))
				$file	= basename($file);
			else
				$file	= substr($file,3,strlen($file));
			$dload_dir_ops['/'.$file] = $file;
			}
			$this->add_combobox($defs,
					'dload_dir', '%tr%catalogue',
					$dload_dir, $dload_dir_ops, 0, true);
		}
		if ($path_dload == 1) {
		 $this->add_button($defs,
            'dload_path_smb',
            '%tr%the_path_username_and_password_smb',
            '%tr%amend',
            500
        );	
		}	
		$skin_ops = array();
        $skin_ops['default'] = '%tr%by_default';
        $skin_ops['juniperus'] = 'Classic';

        $skin = isset($plugin_cookies->skin) ? $plugin_cookies->skin : 'default';
        $this->add_combobox
        (
            $defs,
            'skin',
            '%tr%skin',
     
       $skin, $skin_ops, 0, true
        );
		if (HD::plugin_login($plugin_cookies) == true){
		$this->add_combobox($defs,
        	    'use_marked',
                '%tr%use_marked',
                $use_marked, $show_ops, 0, true
            );
		}
       return $defs;
    }

    ///////////////////////////////////////////////////////////////////////
	public function do_get_export_data_defs(&$plugin_cookies ,$handler)
    {
		$defs = array();
		ControlFactory::add_label($defs, '%tr%attention', '%tr%when_you_upload_and_download_files');
		ControlFactory::add_label($defs, "", '%tr%to_be_overwritten_you_may_lose');
		ControlFactory::add_label($defs, "", '%tr%changes_made_previously');
		$this->add_button
            (
                $defs,
                'export_YouTube_data',
                '%tr%upload_data',
                '%tr%plugin_to_drive',
                0
            );
	$this->add_button
            (
                $defs,
                'import_YouTube_data',
                '%tr%download_data',
                '%tr%drive_to_plugin',
                0
            );
	ControlFactory::add_close_dialog_button($defs,
                '%tr%cancel', 300);	
        return $defs;
    }
	public function do_get_data_path_smb_defs(&$plugin_cookies)
    {
        $data_ip_path = isset($plugin_cookies->data_ip_path) ? 
		$plugin_cookies->data_ip_path : '';
		$data_smb_user = isset($plugin_cookies->data_smb_user) ? 
		$plugin_cookies->data_smb_user : 'guest';
		$data_smb_pass = isset($plugin_cookies->data_smb_pass) ? 
		$plugin_cookies->data_smb_pass : 'guest';
		$defs = array();
		$this->add_text_field($defs,
                    'data_ip_path',
					'%tr%the_path_to_smb_folder_ip_folder_name',
                    $data_ip_path, 0, 0, 0, 1, 500, 0, 0
            );
        $this->add_text_field($defs,
                    'data_smb_user',
                    '%tr%username_smb_folder',
                    $data_smb_user, 0, 0, 0, 1, 500, 0, 0
            );

		$this->add_text_field($defs,
                    'data_smb_pass',
                    '%tr%password_smb_folder',
                    $data_smb_pass, 0, 1, 0, 1, 500, 0, 0
            ); 
        $data_path_smb_apply = UserInputHandlerRegistry::create_action($this, 'data_path_smb_apply');
        ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,
            'data_path_smb_apply', 'OK', 250,$data_path_smb_apply);
        ControlFactory::add_close_dialog_button($defs,
            '%tr%cancel', 250);
 
        return $defs;
    }
	public function do_get_dload_path_smb_defs(&$plugin_cookies)
    {
        $dload_ip_path = isset($plugin_cookies->dload_ip_path) ? 
		$plugin_cookies->dload_ip_path : '';
		$dload_smb_user = isset($plugin_cookies->dload_smb_user) ? 
		$plugin_cookies->dload_smb_user : 'guest';
		$dload_smb_pass = isset($plugin_cookies->dload_smb_pass) ? 
		$plugin_cookies->dload_smb_pass : 'guest';
		$defs = array();
		$this->add_text_field($defs,
                    'dload_ip_path',
					'%tr%the_path_to_smb_folder_ip_folder_name',
                    $dload_ip_path, 0, 0, 0, 1, 500, 0, 0
            );
        $this->add_text_field($defs,
                    'dload_smb_user',
                    '%tr%username_smb_folder',
                    $dload_smb_user, 0, 0, 0, 1, 500, 0, 0
            );

		$this->add_text_field($defs,
                    'dload_smb_pass',
                    '%tr%password_smb_folder',
                    $dload_smb_pass, 0, 1, 0, 1, 500, 0, 0
            ); 
        $dload_path_smb_apply = UserInputHandlerRegistry::create_action($this, 'dload_path_smb_apply');
        ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,
            'dload_path_smb_apply', 'OK', 250,$dload_path_smb_apply);
        ControlFactory::add_close_dialog_button($defs,
            '%tr%cancel', 250);
 
        return $defs;
    }
	public function do_get_reboot_defs()
    {
        $defs = array();
        ControlFactory::add_label($defs, "", '%tr%to_apply_the_changes_necessary_to_restart_the_player');
		ControlFactory::add_label($defs, "", '%tr%reload_this_player_right_now');
		$reboot = UserInputHandlerRegistry::create_action($this, 'reboot');
        ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'reboot', '%tr%yes', 250, $reboot);
		ControlFactory::add_close_dialog_button($defs, '%tr%no', 250);
        return $defs;
    }
	public function do_get_unlogin_defs()
    {
        $defs = array();
        ControlFactory::add_label($defs, "%tr%attention", '%tr%dialog_1');
		ControlFactory::add_label($defs, "", '%tr%dialog_2');
		ControlFactory::add_label($defs, "URL:", '%tr%dialog_3');
		$unlogin = UserInputHandlerRegistry::create_action($this, 'unlogin');
        ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'unlogin', '%tr%yes', 250, $unlogin);
		ControlFactory::add_close_dialog_button($defs, '%tr%no', 250);
        return $defs;
    }
	public function do_get_login_defs($device_code, $user_code, $verification_url, $expires_in, $plugin_cookies)
    {
        $defs = array();
        ControlFactory::add_label($defs, 'URL:', $verification_url);
		ControlFactory::add_label($defs, '%tr%user_code', $user_code);
		ControlFactory::add_label($defs, '%tr%attention', '%tr%dialog_4');
		ControlFactory::add_label($defs, '', '%tr%dialog_5');
		$add_params ['device_code'] = $device_code;
		ControlFactory::add_button_close($defs, $this, $add_params,'login_save', '', 'OK', 250);
        return $defs;
    }
    public function do_get_search_defs(&$plugin_cookies)
    {
        $defs = array();
        $search_text = HD::get_item('search_item', &$plugin_cookies);
        $use_osk = isset($plugin_cookies->use_osk) ? $plugin_cookies->use_osk : 'yes';
        $this->add_text_field($defs,
                'search', "",
                $search_text, 0, 0,
                ($use_osk === 'yes' ? 1 : 0),
                true, 1300, 0, true
        );
        if ($use_osk === 'yes')
            ControlFactory::add_vgap($defs, 500);
        else
            ControlFactory::add_vgap($defs, 50);
		$do_new_search_action = UserInputHandlerRegistry::create_action($this, 'do_new_search');
		//video,channel,playlist
		ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'video',
                '%tr%search_video',
                400, $do_new_search_action);
		ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'playlist',
                '%tr%search_playlists',
                400, $do_new_search_action);
		ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'channel',
                '%tr%search_channels',
                400, $do_new_search_action);
        ControlFactory::add_custom_close_dialog_and_apply_buffon($defs,'video,channel,playlist',
                '%tr%search_all',
                400, $do_new_search_action);
        return $defs;
    }

    ///////////////////////////////////////////////////////////////////////
    public function get_handler_id()
    {
        return self::ID;
    }

    ///////////////////////////////////////////////////////////////////////
    public function get_next_folder_view($media_url, &$plugin_cookies)
    {
        $view_type = isset($plugin_cookies->view_type) ? $plugin_cookies->view_type : 2;
        if ($view_type == 3)
            $view_type = 1;
        else
            ++$view_type;
        $plugin_cookies->view_type = $view_type;
        return $this->get_folder_view($media_url, $plugin_cookies); 
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_folder_view($media_url, &$plugin_cookies)
    {
	     $view_type = isset($plugin_cookies->view_type) ? $plugin_cookies->view_type : 2;
         HD::decode_user_data($media_url, $media_str, $user_data);
	    if ($media_url === 'main_menu')
	    {
            return  array
                    (
                        PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_REGULAR,
                        PluginFolderView::multiple_views_supported  => false,
                        PluginFolderView::data                      => array
                        (
                            PluginRegularFolderView::async_icon_loading => false,
                            PluginRegularFolderView::initial_range =>
                                $this->get_main_menu_items($media_url, $plugin_cookies),
                            PluginRegularFolderView::view_params => self::get_main_menu_folder_view($plugin_cookies),
                            PluginRegularFolderView::base_view_item_params => self::get_main_vip($plugin_cookies),
                            PluginRegularFolderView::not_loaded_view_item_params => array(),
                            PluginRegularFolderView::actions => $this->get_main_menu_action_map($media_url, $plugin_cookies)
                        )
                    );
	    }
        else if 
	    (($media_url === 'main_menu:videos')||(HD::has_attribute($user_data, 'channelId'))||($media_url === 'main_menu:chanell'))
        {
		    switch ($media_url) 
		    {
                    case 'main_menu:videos':
                        $actions = $this->get_category_action_map($media_url, $plugin_cookies);
                        break;
					case 'main_menu:chanell':
                        $actions = $this->get_category_action_map($media_url, $plugin_cookies);
                        break;
		    }
			if (HD::has_attribute($user_data, 'channelId'))
				$actions = $this->get_video_action_map($media_url, $plugin_cookies);
			else
				$actions = $this->get_category_action_map($media_url, $plugin_cookies);
            return  array
                    (
                        PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_REGULAR,
                        PluginFolderView::multiple_views_supported  => false,
                        PluginFolderView::data                      => array
                        (
                            PluginRegularFolderView::async_icon_loading => false,
                            PluginRegularFolderView::initial_range =>
                                $this->get_main_menu_items($media_url, $plugin_cookies),
                            PluginRegularFolderView::view_params => array
                            (
                                ViewParams::num_cols => 1,
								ViewParams::num_rows => 12,
                                ViewParams::paint_details => true,
								ViewParams::item_detailed_info_auto_line_break => true,
								ViewParams::paint_item_info_in_details => true,
								ViewParams::item_detailed_info_font_size => FONT_SIZE_NORMAL,
                            ),
                            PluginRegularFolderView::base_view_item_params => array
							(
								ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
								ViewItemParams::item_layout => HALIGN_LEFT,
								ViewItemParams::icon_valign => VALIGN_CENTER,
								ViewItemParams::icon_dx => 20,
								ViewItemParams::icon_dy => -5,
								ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
								ViewItemParams::item_caption_width => 1550
							),
                            PluginRegularFolderView::not_loaded_view_item_params => array(),
                            PluginRegularFolderView::actions => $actions,
                        )
                    );
	    }
		else if 
	    ($media_url === 'main_menu:subscription')
        {
		    switch ($media_url) 
		    {
                    case 'main_menu:subscription':
                        $actions = $this->get_video_action_map($media_url, $plugin_cookies);
                        break;
		    }

            return  array
                    (
                        PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_REGULAR,
                        PluginFolderView::multiple_views_supported  => false,
                        PluginFolderView::data                      => array
                        (
                            PluginRegularFolderView::async_icon_loading => false,
                            PluginRegularFolderView::initial_range =>
                                $this->get_main_menu_items($media_url, $plugin_cookies),
                            PluginRegularFolderView::view_params => array
                            (
                                ViewParams::num_cols => 1,
								ViewParams::num_rows => 12,
                                ViewParams::paint_details => true,
								ViewParams::item_detailed_info_auto_line_break => true,
								ViewParams::paint_item_info_in_details => true,
								ViewParams::item_detailed_info_font_size => FONT_SIZE_NORMAL,
                            ),
                            PluginRegularFolderView::base_view_item_params => array
							(
								ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
								ViewItemParams::item_layout => HALIGN_LEFT,
								ViewItemParams::icon_valign => VALIGN_CENTER,
								ViewItemParams::icon_dx => 20,
								ViewItemParams::icon_dy => -5,
								ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
								ViewItemParams::item_caption_width => 1550
							),
                            PluginRegularFolderView::not_loaded_view_item_params => array(),
                            PluginRegularFolderView::actions => $this->get_video_action_map($media_url, $plugin_cookies),
                        )
                    );
	    }
		else if 
	    (
		    $media_url === 'main_menu:search'
	    )
        {
		    switch ($media_url) 
		    {
                    case 'main_menu:search':
                        $actions = $this->get_search_action_map($media_url, $plugin_cookies);
                        break;
		    }

            return  array
                    (
                        PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_REGULAR,
                        PluginFolderView::multiple_views_supported  => false,
                        PluginFolderView::data                      => array
                        (
                            PluginRegularFolderView::async_icon_loading => false,
                            PluginRegularFolderView::initial_range =>
                                $this->get_main_menu_items($media_url, $plugin_cookies),
                            PluginRegularFolderView::view_params => array
                            (
                                ViewParams::num_cols => 1,
                                ViewParams::num_rows => 12
                            ),
                            PluginRegularFolderView::base_view_item_params => self::$catalog_vip,
                            PluginRegularFolderView::not_loaded_view_item_params => array(),
                            PluginRegularFolderView::actions => $actions
                        )
                    );
	    }
	    elseif ($media_url === 'setup')
	    {
                $defs = $this->do_get_control_defs($plugin_cookies);
                $folder_view = array
                    (
                	    PluginControlsFolderView::defs => $defs,
                	    PluginControlsFolderView::initial_sel_ndx => -1,
            	    );
                return array
                    (
                	    PluginFolderView::multiple_views_supported => false,
	                    PluginFolderView::archive => null,
        	            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_CONTROLS,
                	    PluginFolderView::data => $folder_view,
            	    );
        }
		

         if
         (
            HD::has_attribute($user_data, 'category_ref')
         )
         {
             if (HD::has_attribute($user_data, 'ser_feed'))
             {
                $actions = $this->get_item_action_map($media_url, $plugin_cookies);
                $not_loaded_item = self::$catalog_vip;
             }
             else if ($media_url === 'main_menu:fav')
             {
                $actions = $this->get_fav_action_map($media_url, $plugin_cookies);
                $not_loaded_item = self::$catalog_vip;
             }
             else
             {
                $actions = $this->get_video_action_map($media_url, $plugin_cookies);
                $not_loaded_item = array();
             }

            return  array
                    (
                        PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_REGULAR,
                        PluginFolderView::multiple_views_supported  => false,
                        PluginFolderView::data                      => array
                        (
                            PluginRegularFolderView::async_icon_loading => false,
                            PluginRegularFolderView::initial_range =>
                                $this->get_regular_folder_items($media_url, 0, $plugin_cookies),
                            PluginRegularFolderView::view_params => array
                            (
                                ViewParams::num_cols => 1,
                                ViewParams::num_rows => 12
                            ),
                            PluginRegularFolderView::base_view_item_params => self::$catalog_vip,
                            PluginRegularFolderView::not_loaded_view_item_params => $not_loaded_item,
                            PluginRegularFolderView::actions => $actions
                        )
                    );
         }
         else if 
         (
            $media_url === 'main_menu:fav' ||
            HD::has_attribute($user_data, 'subcategory_ref') ||
            HD::has_attribute($user_data, 'ser_feed')
         )
         {

             if ($media_url === 'main_menu:fav')
             {
                $actions = $this->get_fav_action_map($media_url, $plugin_cookies);
             }
             else
             {
                $actions = $this->get_item_action_map($media_url, $plugin_cookies);
             }

            return array(
                PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_REGULAR,
                PluginFolderView::multiple_views_supported  => true,
                PluginFolderView::data                      => array(
                    PluginRegularFolderView::async_icon_loading => true,
                    PluginRegularFolderView::initial_range =>
                        $this->get_loading_items(),

                    PluginRegularFolderView::view_params => array(
                        ViewParams::num_cols => ($view_type == 1 ? 3 : 1),
                        ViewParams::num_rows => ($view_type == 1 ? 3 : ($view_type == 2 ? 3 : ($view_type == 4 ? 1 : 10))),
                        ViewParams::paint_details => ($view_type == 4 ? false : true),
                        ViewParams::zoom_detailed_icon => true,
                        ViewParams::item_detailed_info_auto_line_break => true,
                        ViewParams::paint_item_info_in_details => true,
                        ViewParams::item_detailed_info_font_size => FONT_SIZE_NORMAL,
						
                        
                        ViewParams::paint_sandwich => (($view_type == 1 || $view_type == 4) ? true : false),
                        ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                        ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                        ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                        ViewParams::sandwich_width => 290,
                        ViewParams::sandwich_height => 216,
                        ViewParams::sandwich_icon_upscale_enabled => true,
                        ViewParams::sandwich_icon_keep_aspect_ratio => true,
                    ),

                    PluginRegularFolderView::base_view_item_params => array(
                        ViewItemParams::item_paint_icon => true,
                        ViewItemParams::icon_sel_scale_factor =>1.1,
                        ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::icon_dx => 10,
                        ViewItemParams::icon_dy => -5,
                        ViewItemParams::icon_width => ($view_type == 1 ? 290 : ($view_type == 2 ? 290 : ($view_type == 4 ? 250 : 50))),
                        ViewItemParams::icon_height => ($view_type == 1 ? 216 : ($view_type == 2 ? 216 : ($view_type == 4 ? 350 : 50))),
                        ViewItemParams::icon_sel_margin_top => 0,
                        ViewItemParams::item_paint_caption => ($view_type == 1 ? false : true),
                        ViewItemParams::item_caption_width => ($view_type == 2 ? 850 : 1100)
                    ),

                    PluginRegularFolderView::not_loaded_view_item_params => array(
                        ViewItemParams::item_paint_icon => true,
                        ViewItemParams::icon_width => ($view_type == 1 ? 290 : ($view_type == 2 ? 290 : 50)),
                        ViewItemParams::icon_height => ($view_type == 1 ? 216 : ($view_type == 2 ? 216 : 50)),
                        ViewItemParams::icon_path => ($view_type != 3 ? 'gui_skin://large_icons/movie.aai' : 'gui_skin://small_icons/movie.aai')
                    ),

                    PluginRegularFolderView::actions => $actions
                )
            );
         }
         else if
         (
            HD::has_attribute($user_data, 'season_ref') &&
            !HD::has_attribute($user_data, 'info')
         )
         {
				$add_fav_action = UserInputHandlerRegistry::create_action(
                        $this, 'add_favorite');
				$add_fav_action['caption'] = (
						'%tr%add_favorite'
						);
				$show_related_view = UserInputHandlerRegistry::create_action(
                        $this, 'related_view');
				$search_view = UserInputHandlerRegistry::create_action(
								$this, 'do_search_menu');
				$search_view['caption'] = '%tr%search';
				$popup_action = UserInputHandlerRegistry::create_action(
                        $this, 'pop_up_menu');
				$setup_view = UserInputHandlerRegistry::create_action(
								$this, 'setup');
				$setup_view['caption'] = '%tr%settings';
				
                $actions = array
                (
                        GUI_EVENT_KEY_ENTER => $this->get_play_action($media_url, $plugin_cookies),
                        GUI_EVENT_KEY_PLAY => $this->get_play_action($media_url, $plugin_cookies),
						GUI_EVENT_KEY_B_GREEN => $search_view,
						//GUI_EVENT_KEY_D_BLUE => $sort_page,
						GUI_EVENT_KEY_C_YELLOW => $add_fav_action,
						GUI_EVENT_KEY_POPUP_MENU => $popup_action,
						GUI_EVENT_KEY_SETUP => $setup_view,
						GUI_EVENT_KEY_SELECT => $show_related_view,
                );

            return array
            (
                PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_REGULAR,
                PluginFolderView::multiple_views_supported  => false,
                PluginFolderView::data                      => array(
                    PluginRegularFolderView::async_icon_loading => true,
                    PluginRegularFolderView::initial_range =>
                        $this->get_regular_folder_items($media_url, 0, $plugin_cookies),

                    PluginRegularFolderView::view_params => array(
                        ViewParams::num_cols => 1,
                        ViewParams::num_rows => 10,
						ViewParams::paint_details => true,
                        ViewParams::item_detailed_info_auto_line_break => true,
                        ViewParams::paint_item_info_in_details => true,
						
                    ),

                    PluginRegularFolderView::base_view_item_params => array(
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 20,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                    ViewItemParams::item_caption_width => 1350
                    ),

                    PluginRegularFolderView::not_loaded_view_item_params => array(),

                    PluginRegularFolderView::actions => $actions
                )
            );
         }
         
         if (HD::has_attribute($user_data, 'info'))
         {
            $authorize = 0;
			if (HD::has_attribute($user_data, 'authorize'))
				$authorize = $user_data->authorize;
			$c = $this->parse_season_info($user_data->video_id,$user_data->playlistItem, $user_data->season_title, $authorize, &$plugin_cookies);
            HD::decode_user_data($c, $media_str, $user_data);

            $movie = array(
                PluginMovie::name => $user_data->title,
                PluginMovie::name_original => $user_data->name_original,
                PluginMovie::description => $user_data->description,
                PluginMovie::poster_url => $user_data->video_image_url,
                PluginMovie::length_min => '',
                PluginMovie::year => '',
                PluginMovie::directors_str => '',
                PluginMovie::scenarios_str => '',
                PluginMovie::actors_str => '',
                PluginMovie::genres_str => $user_data->genre,
                PluginMovie::rate_imdb => '',
                PluginMovie::rate_kinopoisk => '',
                PluginMovie::rate_mpaa => '',
                PluginMovie::country => $user_data->country,
				PluginMovie::rate_details   => $user_data->rate_details,
				PluginMovie::details =>  $user_data->details,
                PluginMovie::budget => ''
                );
			$itemID = false;
			if (HD::has_attribute($user_data, 'itemID'))
				$itemID = $user_data->itemID;
            $right_button_action = UserInputHandlerRegistry::create_action(
                        $this, 'additional');
            $right_button_action['caption'] = '%tr%actions';
            $right_button_caption = $right_button_action['caption'];
			
			$movie_folder_view = array
            (
                PluginMovieFolderView::movie => $movie,
                PluginMovieFolderView::has_right_button => true,
                PluginMovieFolderView::right_button_caption => $right_button_caption,
                PluginMovieFolderView::right_button_action => $right_button_action,
                PluginMovieFolderView::has_multiple_series => ($user_data->n_series > 1),
                PluginMovieFolderView::series_media_url => HD::encode_user_data(
                                                                array(
                                                                    'season_ref' => $user_data->video_id,
                                                                    'season_title' => $user_data->title,
                                                                    'n_series' => $user_data->n_series,
																	'playlistItem' => $user_data->playlistItem,
																	'authorize' => $authorize,
																	'itemID' => $itemID,
                                                                )
                                                           )
            );

             return array
                (
                    PluginFolderView::multiple_views_supported => false,
                    PluginFolderView::archive => null,
                    PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_MOVIE,
                    PluginFolderView::data => $movie_folder_view
                );
         }
         else if (HD::has_attribute($user_data, 'video_id'))
         {
				$add_fav_action = UserInputHandlerRegistry::create_action(
                        $this, 'add_favorite');
				$add_fav_action['caption'] = (
						'%tr%add_favorite'
						);
				$show_related_view = UserInputHandlerRegistry::create_action(
                        $this, 'related_view');
				$search_view = UserInputHandlerRegistry::create_action(
								$this, 'do_search_menu');
				$search_view['caption'] = '%tr%search';
				$popup_action = UserInputHandlerRegistry::create_action(
                        $this, 'pop_up_menu');
				$setup_view = UserInputHandlerRegistry::create_action(
								$this, 'setup');
				$setup_view['caption'] = '%tr%settings';
				
                $actions = array
                (
                        GUI_EVENT_KEY_ENTER => $this->get_play_action($media_url, $plugin_cookies),
                        GUI_EVENT_KEY_PLAY => $this->get_play_action($media_url, $plugin_cookies),
						GUI_EVENT_KEY_B_GREEN => $search_view,
						GUI_EVENT_KEY_C_YELLOW => $add_fav_action,
						GUI_EVENT_KEY_POPUP_MENU => $popup_action,
						GUI_EVENT_KEY_SETUP => $setup_view,
						GUI_EVENT_KEY_SELECT => $show_related_view,
						
                );
            
            return array(
                PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_REGULAR,
                PluginFolderView::multiple_views_supported  => false,
                PluginFolderView::data                      => array(
                    PluginRegularFolderView::async_icon_loading => true,
                    PluginRegularFolderView::initial_range =>
                        $this->get_regular_folder_items($media_url, 0, $plugin_cookies),

                    PluginRegularFolderView::view_params => array(
                        ViewParams::num_cols => 1,
                        ViewParams::num_rows => 10,
                        ViewParams::paint_details => true,
                        ViewParams::item_detailed_info_auto_line_break => true,
                        ViewParams::paint_item_info_in_details => true,
  
                    ),

                    PluginRegularFolderView::base_view_item_params => array(
                        ViewItemParams::item_paint_icon => true,
                        ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
	                ViewItemParams::item_layout => HALIGN_LEFT,
       		        ViewItemParams::icon_valign => VALIGN_CENTER,
        	        ViewItemParams::icon_dx => 20,
        	        ViewItemParams::icon_dy => -5,
        	        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
        	        ViewItemParams::item_caption_width => 1550
                    ),

                    PluginRegularFolderView::not_loaded_view_item_params => array(),

                    PluginRegularFolderView::actions => $actions
                )
            );
         }

	    if ($media_url === 'main_menu:fav')
            $actions = $this->get_fav_action_map($media_url, $plugin_cookies);
	    else
	        $actions = $this->get_item_action_map($media_url, $plugin_cookies);

        return array(
            PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_REGULAR,
            PluginFolderView::multiple_views_supported  => true,
            PluginFolderView::data                      => array(
                PluginRegularFolderView::async_icon_loading => true,
                PluginRegularFolderView::initial_range =>
                    $this->get_loading_items(),

                PluginRegularFolderView::view_params => array(
                    ViewParams::num_cols => ($view_type == 1 ? 3 : 1),
                    ViewParams::num_rows => ($view_type == 1 ? 3 : ($view_type == 2 ? 3 : 10)),
                    ViewParams::paint_details => true,
                    ViewParams::zoom_detailed_icon => true,
                    ViewParams::item_detailed_info_auto_line_break => true,
                    ViewParams::paint_item_info_in_details => true,
                    ViewParams::item_detailed_info_font_size => FONT_SIZE_NORMAL,
                    
                    ViewParams::paint_sandwich => ($view_type == 1 ? true : false),
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 290,
                    ViewParams::sandwich_height => 216,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
                ),

                PluginRegularFolderView::base_view_item_params => array(
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::icon_sel_scale_factor =>1.1,
                    ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 10,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::icon_width => ($view_type == 1 ? 290 : ($view_type == 2 ? 290 : 50)),
                    ViewItemParams::icon_height => ($view_type == 1 ? 216 : ($view_type == 2 ? 216 : 50)),
                    ViewItemParams::icon_sel_margin_top => 0,
                    ViewItemParams::item_paint_caption => ($view_type == 1 ? false : true),
                    ViewItemParams::item_caption_width => ($view_type == 2 ? 850 : 1100)
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array(
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::icon_width => ($view_type == 1 ? 290 : ($view_type == 2 ? 290 : 50)),
                    ViewItemParams::icon_height => ($view_type == 1 ? 216 : ($view_type == 2 ? 216 : 50)),
                    ViewItemParams::icon_path => ($view_type != 3 ? 'gui_skin://large_icons/movie.aai' : 'gui_skin://small_icons/movie.aai')
                ),

                PluginRegularFolderView::actions => $actions
            )
        );

        throw new Exception('Unknown media url');
    }

    ///////////////////////////////////////////////////////////////////////
    private function parse_season_info($season_ref, $playlistItem, $season_title, $authorize, &$plugin_cookies)
    {
		$show_comment = isset($plugin_cookies->show_comment) ? $plugin_cookies->show_comment : 'yes';
		$items = array();
		if ($playlistItem==0){
		$jsd = json_decode(HD::http_get_document(HOST_API_URL."/videos?id=$season_ref&key=".API_KEY."&part=snippet,contentDetails,statistics,status"), true);
		$video_image = str_replace("https", "http", $jsd['items']['0']['snippet']['thumbnails']['high']['url']);
		$video_title =  str_remove_spec($jsd['items']['0']['snippet']['title']);
		$description =  $jsd['items']['0']['snippet']['description'];
        $country = str_replace(array ("T",".000Z"), " ", $jsd['items']['0']['snippet']['publishedAt']);
        $genre = strtoupper($jsd['items']['0']['contentDetails']['definition']);
		$name_original = $jsd['items']['0']['snippet']['channelTitle'];
		$rate_details['Time:'] = str_replace(array ("PT","M","S","H"), array ("",":","",":"), $jsd['items']['0']['contentDetails']['duration']);
		$rate_details["Like:"] = $jsd['items']['0']['statistics']['likeCount'];
		$rate_details["Dislike:"] = $jsd['items']['0']['statistics']['dislikeCount'];
		$details["View:"] = $jsd['items']['0']['statistics']['viewCount'];
		$details["Comment:"] = $jsd['items']['0']['statistics']['commentCount'];
		//$details["Favorite:"] = $jsd['items']['0']['statistics']['favoriteCount'];
		if (HD::plugin_login($plugin_cookies) == true){
		$jsdl = HD::get_authorization_document(HOST_API_URL."/videos/getRating?id=".$season_ref."&key=".API_KEY, &$plugin_cookies);
		$genre = $genre. " [Rating:". $jsdl['items']['0']['rating'].']';
		}
		$ndx = 1;
		if (($show_comment == 'yes')&& ($jsd['items']['0']['statistics']['commentCount'] > 0)){
			$jsdq = json_decode(HD::http_get_document(HOST_API_URL."/commentThreads?part=snippet&maxResults=100&videoId=$season_ref&key=".API_KEY), true);
			if (is_array($jsdq)){
			foreach ($jsdq['items'] as $value){
			$item = str_remove_tag($value['snippet']['topLevelComment']['snippet']['authorDisplayName']  .': '. $value['snippet']['topLevelComment']['snippet']['textDisplay']);
			$details[$ndx] = wordwrap($item, 75, "\n");
			++$ndx;
			}}
		}
        $n_series = 1;
		if ($jsd['items']['0']['snippet']['liveBroadcastContent'] == 'live')
		$n_series = 2;
		}
		else if ($playlistItem==1)
        {
			if ($authorize == 1)
				$jsd = HD::get_authorization_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&playlistId=$season_ref&key=".API_KEY, &$plugin_cookies);
			else
				$jsd = json_decode(HD::http_get_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&playlistId=$season_ref&key=".API_KEY), true);
			$video_title =  $season_title;
			$video_image = str_replace("https", "http", $jsd['items']['0']['snippet']['thumbnails']['medium']['url']);
			$ndx_series = 0;
			$description = '';
			$video = array();
			$video = $jsd['items'];
			if (isset($jsd['nextPageToken'])){
				$i=0;
				$m_last_ref = $jsd['nextPageToken'];
				if ($authorize == 1)
					$jsdn = HD::get_authorization_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&pageToken=$m_last_ref&playlistId=$season_ref&key=".API_KEY, &$plugin_cookies);
				else
					$jsdn = json_decode(HD::http_get_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&pageToken=$m_last_ref&playlistId=$season_ref&key=".API_KEY), true);
				$video = array_merge($video,$jsdn['items']);
				do {
					++$i;
				if (isset($jsdn['nextPageToken'])){
				$m_last_ref = $jsdn['nextPageToken'];
				if ($authorize == 1)
					$jsdn = HD::get_authorization_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&pageToken=$m_last_ref&playlistId=$season_ref&key=".API_KEY, &$plugin_cookies);
				else
					$jsdn = json_decode(HD::http_get_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&pageToken=$m_last_ref&playlistId=$season_ref&key=".API_KEY), true);
				$video = array_merge($video,$jsdn['items']);
				}
				else
					break;
				} while ($i = 25);
			}
			foreach ($video as $value)
				{	
					++$ndx_series;
					$description .= "[$ndx_series] ". str_remove_spec($value['snippet']['title']) . "                                                                                                                     ";
				}
			$n_series = $ndx_series;
			$name_original = $jsd['items']['0']['snippet']['channelTitle'];
			$country = '';
			$genre = '';
			$details[' '] = ' ';
			$rate_details['Items:'] = $jsd['pageInfo']['totalResults'];;
		}
        return  HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'n_series' => $n_series,
                        'page_ref' => $season_ref,
                        'video_image_url' => $video_image,
                        'title' => $video_title,
                        'genre' => str_remove_spec($genre),
                        'country' => str_remove_spec($country),
                        'name_original' => $name_original,
						'rate_details' => $rate_details,
						'details' => $details,
                        'description' => str_remove_spec($description),
						'playlistItem' => $playlistItem,
                    )
                );
    }
    ///////////////////////////////////////////////////////////////////////

    private function parse_season($season_ref, $playlistItem, $season_title, $authorize, &$plugin_cookies)
    {
		$items = array();
		$is_new = false;
        $ndx_series = 0;
		$pl_create = (HD::get_item(str_replace(':', '', HD::get_mac_addr()), &$plugin_cookies)!=='') ? HD::get_item(str_replace(':', '', HD::get_mac_addr()), &$plugin_cookies) : 'no';
		if ($playlistItem==0){
		$jsd = json_decode(HD::http_get_document(HOST_API_URL."/videos?id=$season_ref&key=".API_KEY."&part=snippet,contentDetails,statistics,status"), true);                      
        if (!isset($jsd['items']['0']['snippet']['thumbnails']))
					return false;
		if ($jsd['items']['0']['snippet']['liveBroadcastContent'] == 'live'){
		$media_urls = Youtube::retrieve_playback_url($season_ref, false, $plugin_cookies);
		foreach ($media_urls[1] as $key => $value){
			if (isset($plugin_cookies->$season_ref))
                    if (!ListUtil::is_in_list($plugin_cookies->$season_ref, $value['snippet']['resourceId']['videoId']))
                        $is_new = true;
                array_push
                (
                    $items,
                    HD::encode_user_data
                    (
                        array
                        (
							'episode_title' => str_remove_spec(($is_new ? '[NEW] ' : '') . str_remove_spec($jsd['items']['0']['snippet']['title']). " [$value]"),
                            'episode_ref' => $media_urls[2][$key],
							'season_title' => str_remove_spec($jsd['items']['0']['snippet']['title']),
                            'season_ref' => $season_ref,
                            'ndx_series' => $ndx_series,
                            'poster_url' => str_replace("https", "http", $jsd['items']['0']['snippet']['thumbnails']['standard']['url']),
                            'description' => str_remove_spec($jsd['items']['0']['snippet']['description']),
							'channelTitle' => str_remove_spec($jsd['items']['0']['snippet']['channelTitle']),
							'publishedAt' => str_replace(array ("T",".000Z"), " ", $jsd['items']['0']['snippet']['publishedAt']),
							'playlistItem' => $playlistItem,
							'position' => $ndx_series+1,
                        )
                    )
                );
                ++$this->m_items_count;
                ++$ndx_series;
		}
		return $items;
		}
        if (($this->oMediaUrl !== null)&&($pl_create !=='no'))
        {
            $items = array();
			$folder = FolderCache::get($this->oMediaUrl);
            $videos = $folder->get_elements(0, $plugin_cookies);
			if ($pl_create ==2){
			$videos = array_reverse($videos);
			$videos = array_values($videos);
			}
                foreach ($videos as $v) {
                    HD::decode_user_data($v, $media_str, $user_data);
                    if (HD::has_attribute($user_data, 'video_id'))
                        $video_id = $user_data->video_id;
                    if (HD::has_attribute($user_data, 'season_title'))
                        $v_title = $user_data->season_title;
                    if (HD::has_attribute($user_data, 'season_ref'))
                        $v_ref = $user_data->season_ref;
					if (HD::has_attribute($user_data, 'season_image'))
                        $s_image = $user_data->season_image;
					if (HD::has_attribute($user_data, 'season_image'))
                        $s_image = $user_data->season_image;
					if (HD::has_attribute($user_data, 'season_desc'))
                        $s_desc = $user_data->season_desc;
                    if (HD::has_attribute($user_data, 'playlistItem'))
					if ($user_data->playlistItem !=0)
						continue;
                    array_push
                    (
                        $items,
                        HD::encode_user_data
                        (
                            array
                            (
                                'episode_title' => $v_title,
                                'episode_ref' => $video_id,
                                'season_title' => str_remove_spec($jsd['items']['0']['snippet']['title']),
                                'season_ref' => str_remove_spec($season_ref),
                                'ndx_series' => $ndx_series,
                                'poster_url' => $s_image,
                                'description' => $s_desc,
								'channelTitle' => str_remove_spec($jsd['items']['0']['snippet']['channelTitle']),
								'publishedAt' => str_replace(array ("T",".000Z"), " ", $jsd['items']['0']['snippet']['publishedAt']),
								'playlistItem' => $playlistItem,
								'playAll' => 1,
                            )
                        )
                    );
                    ++$ndx_series;
					++$this->m_items_count;
                }
				if ($pl_create ==3)
				shuffle($items);
				return $items;
        }
        // sersar # code end
		if (isset($plugin_cookies->$season_ref))
        if (!ListUtil::is_in_list($plugin_cookies->$season_ref, $season_ref))
        $is_new = true;
                array_push
                (
                    $items,
                    HD::encode_user_data
                    (
                        array
                        (
                            'episode_title' => str_remove_spec(($is_new ? '[NEW] ' : '') . str_remove_spec($jsd['items']['0']['snippet']['title'])),
                            'episode_ref' => $season_ref,
							'season_title' => str_remove_spec($jsd['items']['0']['snippet']['title']),
                            'season_ref' => $season_ref,
                            'ndx_series' => 0,
                            'poster_url' => str_replace("https", "http", $jsd['items']['0']['snippet']['thumbnails']['medium']['url']),
                            'description' => str_remove_spec($jsd['items']['0']['snippet']['description']),
							'channelTitle' => str_remove_spec($jsd['items']['0']['snippet']['channelTitle']),
							'publishedAt' => str_replace(array ("T",".000Z"), " ", $jsd['items']['0']['snippet']['publishedAt']),
							'playlistItem' => $playlistItem,
                        )
                    )
                );
                ++$this->m_items_count;
		return $items;
		}
		if ($playlistItem==1){
			if ($authorize == 1)
				$jsd = HD::get_authorization_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&playlistId=$season_ref&key=".API_KEY, &$plugin_cookies);
			else
				$jsd = json_decode(HD::http_get_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&playlistId=$season_ref&key=".API_KEY), true);
		$video = array();
		$video = $jsd['items'];
		if (isset($jsd['nextPageToken'])){
			$i=0;
			$m_last_ref = $jsd['nextPageToken'];
			if ($authorize == 1)
				$jsdn = HD::get_authorization_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&pageToken=$m_last_ref&playlistId=$season_ref&key=".API_KEY, &$plugin_cookies);
			else
				$jsdn = json_decode(HD::http_get_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&pageToken=$m_last_ref&playlistId=$season_ref&key=".API_KEY), true);
			$video = array_merge($video,$jsdn['items']);
			do {
				++$i;
			if (isset($jsdn['nextPageToken'])){
			$m_last_ref = $jsdn['nextPageToken'];
			if ($authorize == 1)
				$jsdn = HD::get_authorization_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&pageToken=$m_last_ref&playlistId=$season_ref&key=".API_KEY, &$plugin_cookies);
			else
				$jsdn = json_decode(HD::http_get_document(HOST_API_URL."/playlistItems?part=snippet&maxResults=50&pageToken=$m_last_ref&playlistId=$season_ref&key=".API_KEY), true);
			$video = array_merge($video,$jsdn['items']);
			}
			else
				break;
			} while ($i = 25);
		}
		foreach ($video as $value)
            {	
                if (!isset($value['snippet']['thumbnails']))
					continue;
				
				if (isset($plugin_cookies->$season_ref))
                    if (!ListUtil::is_in_list($plugin_cookies->$season_ref, $value['snippet']['resourceId']['videoId']))
                        $is_new = true;
                array_push
                (
                    $items,
                    HD::encode_user_data
                    (
                        array
                        (
                            'episode_title' => str_remove_spec(($is_new ? '[NEW] ' : '') . str_remove_spec($value['snippet']['title'])),
                            'episode_ref' => $value['snippet']['resourceId']['videoId'],
							'season_title' => $season_title,
                            'season_ref' => str_remove_spec($season_ref),
                            'ndx_series' => $ndx_series,
                            'poster_url' => str_replace("https", "http", $value['snippet']['thumbnails']['high']['url']),
                            'description' => str_remove_spec($value['snippet']['description']),
							'channelTitle' => str_remove_spec($value['snippet']['channelTitle']),
							'publishedAt' => str_replace(array ("T",".000Z"), " ", $value['snippet']['publishedAt']),
							'position' => $value['snippet']['position']+1,
							'playlistItem' => $playlistItem,
							'authorize' => $authorize,
							'season_channel' => $value['snippet']['channelId'],
                        )
                    )
                );
                ++$this->m_items_count;
                ++$ndx_series;
            }
			if ($pl_create ==3)
				shuffle($items);
			return $items;
		}
    }
    ///////////////////////////////////////////////////////////////////////

    public function get_regular_folder_items($media_url, $from_ndx, &$plugin_cookies)
    {
	    if 
	    (
		    $media_url === 'main_menu' ||
		    $media_url === 'main_menu:videos' ||
			$media_url === 'main_menu:chanell' ||
		    $media_url === 'main_menu:audio' ||
		    $media_url === 'main_menu:search'
	    )
        {
            return $this->get_main_menu_items($media_url, $plugin_cookies);
        }

        if (intval($from_ndx) > 0)
            --$from_ndx; // replace aux "loading" item
            
	    $videos = false;
        $folder_items = array();
        $total_num = 0;

        HD::decode_user_data($media_url, $media_str, $user_data);
		if (HD::has_attribute($user_data, 'channelId'))
		{
            return $this->get_main_menu_items($media_url, $plugin_cookies);
        }
        if (HD::has_attribute($user_data, 'season_ref'))
        {
            if (HD::has_attribute($user_data, 'season_ref'))
                $season_ref = $user_data->season_ref;
            else if (HD::has_attribute($user_data, 'fav'))
                $season_ref = $user_data->fav;
            $videos = $this->parse_season($season_ref, $user_data->playlistItem,$user_data->season_title, $user_data->authorize, $plugin_cookies);
            $total_num = 0;
                
            if ($videos === false)
            {
                $caption = '%tr%no_more_items_found';
                $m_url = 'dummy';
                if (HD::has_attribute($user_data, 'fav'))
                {
                    $caption = '%tr%not_found';
                    $m_url = $media_url;
                }
		        $more_items_available = 0;
                
                if ($media_url === 'main_menu:fav')
                {
                    $folder->set_expired();
                }

                $view_type = isset($plugin_cookies->view_type) ? $plugin_cookies->view_type : 2;
		        array_push
		        (
                    $folder_items,
                    array
			        (
                        PluginRegularFolderItem::media_url => $m_url,
	                    PluginRegularFolderItem::caption => $caption,
                	    PluginRegularFolderItem::view_item_params => array
                        	    (
                                    ViewItemParams::icon_width => ($view_type == 1 ? 290 : ($view_type == 2 ? 290 : 50)),
                                    ViewItemParams::icon_height => ($view_type == 1 ? 216 : ($view_type == 2 ? 216 : 50)),
                                    ViewItemParams::icon_path => ($view_type != 3 ? 'gui_skin://large_icons/movie.aai' : 'gui_skin://small_icons/movie.aai'),
                		            ViewItemParams::item_detailed_icon_path => 'missing://'
                        		)
			        )
		        );
                ++$total_num;
                
                $this->fav_build_in_progess = false;
            }
            else
            {
                $more_items_available = 0;
                foreach ($videos as $v)
                {
                    HD::decode_user_data($v, $media_str, $user_data);

                    array_push
                    (
                        $folder_items, 
                        array
                        (
                            PluginRegularFolderItem::media_url => $v,
                            PluginRegularFolderItem::caption => "[$user_data->position] $user_data->episode_title",
                            PluginRegularFolderItem::view_item_params => array(
                                        ViewItemParams::item_paint_icon => true,
                                        ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                                        ViewItemParams::item_layout => HALIGN_LEFT,
                                        ViewItemParams::icon_valign => VALIGN_CENTER,
                                        ViewItemParams::icon_dx => 20,
                                        ViewItemParams::icon_dy => -5,
                                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                                        ViewItemParams::item_caption_width => 1100,
										ViewItemParams::item_detailed_info => "$user_data->episode_title||$user_data->channelTitle||$user_data->publishedAt||$user_data->description",
										ViewItemParams::item_detailed_icon_path => $user_data->poster_url
                            ),
                        )
                     );
            
                    ++$total_num;
                }
            }
            return array(
                PluginRegularFolderRange::total => $total_num,
                PluginRegularFolderRange::count => count($folder_items),
                PluginRegularFolderRange::more_items_available => $more_items_available,
                PluginRegularFolderRange::from_ndx => $from_ndx,
                PluginRegularFolderRange::items => $folder_items
            );
        }
        
        $folder = FolderCache::get($media_url);

        if (HD::has_attribute($user_data, 'category_ref'))
        {
            $videos = $folder->get_elements($from_ndx, $plugin_cookies);
            $total_num = 0;
                
            if ($videos === false)
            {
                $caption = '%tr%no_more_items_found';
                $m_url = 'dummy';
                if (HD::has_attribute($user_data, 'fav'))
                {
                    $caption = '%tr%not_found';
                    $m_url = $media_url;
                }
		        $more_items_available = 0;
                
                if ($media_url === 'main_menu:fav')
                {
                    $folder->set_expired();
                }

                $view_type = isset($plugin_cookies->view_type) ? $plugin_cookies->view_type : 2;
		        array_push
		        (
                    $folder_items,
                    array
			        (
                        PluginRegularFolderItem::media_url => $m_url,
	                    PluginRegularFolderItem::caption => $caption,
                	    PluginRegularFolderItem::view_item_params => array
                        	    (
                                    ViewItemParams::icon_width => ($view_type == 1 ? 290 : ($view_type == 2 ? 290 : 50)),
                                    ViewItemParams::icon_height => ($view_type == 1 ? 216 : ($view_type == 2 ? 216 : 50)),
                                    ViewItemParams::icon_path => ($view_type != 3 ? 'gui_skin://large_icons/movie.aai' : 'gui_skin://small_icons/movie.aai'),
                		            ViewItemParams::item_detailed_icon_path => 'missing://'
                        		)
			        )
		        );
                ++$total_num;
                
                $this->fav_build_in_progess = false;
            }
            else
            {
                $more_items_available = 1;
                foreach ($videos as $v)
                {
                    HD::decode_user_data($v, $media_str, $user_data);

                    array_push
                    (
                        $folder_items, 
                        array
                        (
                            PluginRegularFolderItem::media_url => $v,
                            PluginRegularFolderItem::caption => $user_data->subcategory_title,
                            PluginRegularFolderItem::view_item_params => self::$catalog_vip
                        )
                     );
            
                    ++$total_num;
                }
            }
            return array(
                PluginRegularFolderRange::total => $total_num,
                PluginRegularFolderRange::count => count($folder_items),
                PluginRegularFolderRange::more_items_available => $more_items_available,
                PluginRegularFolderRange::from_ndx => $from_ndx,
                PluginRegularFolderRange::items => $folder_items
            );
        }
        else if
        (
            HD::has_attribute($user_data, 'subcategory_ref') ||
            HD::has_attribute($user_data, 'ser_feed') ||
            $media_url === 'main_menu:fav'
        )
        {
       	    $videos = $folder->get_elements($from_ndx, $plugin_cookies);
            $total_num = $folder->get_num_elements();
	         // sersar # code start
            if (((int)$from_ndx <= 1)&&($media_url !== 'main_menu:fav'))
                $this->oMediaUrl = $media_url;
            // sersar # code end
           if ($videos === false)
            {
                $caption = '%tr%no_more_items_found';
                $m_url = 'dummy';
                if (HD::has_attribute($user_data, 'fav'))
                {
                    $caption = '%tr%not_found';
                    $m_url = $media_url;
                }
		        $more_items_available = 0;
                
                if ($media_url === 'main_menu:fav')
                {
                    $folder->set_expired();
                }

                $view_type = isset($plugin_cookies->view_type) ? $plugin_cookies->view_type : 2;
		        array_push
		        (
                    $folder_items,
                    array
			        (
                        PluginRegularFolderItem::media_url => $m_url,
	                    PluginRegularFolderItem::caption => $caption,
                	    PluginRegularFolderItem::view_item_params => array
                        	    (
                                    ViewItemParams::icon_width => ($view_type == 1 ? 290 : ($view_type == 2 ? 290 : 50)),
                                    ViewItemParams::icon_height => ($view_type == 1 ? 216 : ($view_type == 2 ? 216 : 50)),
                                    ViewItemParams::icon_path => ($view_type != 3 ? 'gui_skin://large_icons/movie.aai' : 'gui_skin://small_icons/movie.aai'),
                		            ViewItemParams::item_detailed_icon_path => 'missing://'
                        		)
			        )
		        );
                ++$total_num;
                
                $this->fav_build_in_progess = false;
            }
            else
            {
                if ($media_url === 'main_menu:fav')
                    $this->fav_build_in_progess = true;
                else
                    $this->fav_build_in_progess = false;

                $more_items_available = 1;

                foreach ($videos as $v)
                {
	                HD::decode_user_data($v, $media_str, $user_data);
                    $view_type = isset($plugin_cookies->view_type) ? $plugin_cookies->view_type : 2;
					$info = ''; $title = ' '; $channelTitle = ''; $lBC = '';
					$season_date = ''; $season_desc = ''; $c_t = '';
                    if (HD::has_attribute($user_data, 'season_title'))
                        $title = str_replace('^', '', $user_data->season_title);
					if (HD::has_attribute($user_data, 'channelTitle'))
                        $channelTitle = str_replace('^', '', $user_data->channelTitle);
                    if (HD::has_attribute($user_data, 'season_date'))
                        $season_date = str_replace('^', '', $user_data->season_date);
                    if (HD::has_attribute($user_data, 'season_desc'))
                        $season_desc = str_replace('^', '', $user_data->season_desc);
					if (HD::has_attribute($user_data, 'lBC'))
                        $lBC = $user_data->lBC;
					if (HD::has_attribute($user_data, 'playlistItem')){
						if ($user_data->playlistItem == 0)
							$c_t = 'video';
						if ($user_data->playlistItem == 1)
							$c_t = 'playlist';
						if ($user_data->playlistItem == 2)
							$c_t = 'channel';
						}
                    $info = "[$c_t]$lBC||$title||$channelTitle||$season_date||$season_desc";

		            $video_id = '1';
		            $n_series = 1;
		            $ndx_series = 0;
                    $is_has_new = false;
					$channelId = false;
		            if (HD::has_attribute($user_data, 'video_id'))
	                    $video_id = $user_data->video_id;
 		            if (HD::has_attribute($user_data, 'n_series'))
	                    $n_series = $user_data->n_series;
                    if (HD::has_attribute($user_data, 'is_has_new'))
                        $is_has_new = $user_data->is_has_new;
					if (HD::has_attribute($user_data, 'playlistItem'))
                        $playlistItem = $user_data->playlistItem;
					if (HD::has_attribute($user_data, 'channelId'))
                        $channelId = $user_data->channelId;
                    
					if ($view_type == 1)
                    {
                            array_push(
                                $folder_items, 
                                array(
                                    PluginRegularFolderItem::media_url =>
                                        HD::encode_user_data(
                                            array(
				                	            'video_id' => $video_id,
                                                'n_series' => $n_series,
                                                'season_title' => $title,
												'playlistItem' => $playlistItem,
												'season_title' => $user_data->season_title,
												'season_channel' => $channelId,
												'season_image' => $user_data->season_image,
												'authorize' => $user_data->authorize,
												'itemID' => $user_data->itemID,
				                            )
			                        ),
                                    PluginRegularFolderItem::caption => ($is_has_new ? '[NEW] ' . $title : $title),
                                    PluginRegularFolderItem::view_item_params => array(
                                        ViewItemParams::icon_path => $this->get_preview_url($user_data),
                                        ViewItemParams::item_paint_caption => false,
                                        ViewItemParams::item_caption_wrap_enabled => TRUE,
                                        ViewItemParams::item_detailed_info => $info
                                    )
                                ));
                    }
                    else if ($view_type == 2)
                    {
                            array_push(
                                $folder_items, 
                                array(
                                    PluginRegularFolderItem::media_url =>
                                        HD::encode_user_data(
                                            array(
                                                'video_id' => $video_id,
                                                'n_series' => $n_series,
												'playlistItem' => $playlistItem,
												'season_title' => $user_data->season_title,
												'season_channel' => $channelId,
												'season_image' => $user_data->season_image,
												'authorize' => $user_data->authorize,
												'itemID' => $user_data->itemID,
                                            )
                                    ),
                                    PluginRegularFolderItem::caption => ($is_has_new ? '[NEW] ' . $title : $title),
                                    PluginRegularFolderItem::view_item_params => array(
                                        ViewItemParams::icon_path => $this->get_preview_url($user_data),
                                        ViewItemParams::item_detailed_info => $info
                                    )
                                ));
                    }
                    else
                    {
                        array_push(
                            $folder_items, 
                            array(
                                PluginRegularFolderItem::media_url =>
                                    HD::encode_user_data(
                                        array(
                                            'video_id' => $video_id,
                                            'n_series' => $n_series,
											'playlistItem' => $playlistItem,
											'season_title' => $user_data->season_title,
											'season_channel' => $channelId,
											'season_image' => $user_data->season_image,
											'authorize' => $user_data->authorize,
											'itemID' => $user_data->itemID,
                                        )
                                ),
                                PluginRegularFolderItem::caption => ($is_has_new ? '[NEW] ' . $title : $title),
                                PluginRegularFolderItem::view_item_params => array(
                                    ViewItemParams::item_detailed_icon_path => $this->get_preview_url($user_data),
                                    ViewItemParams::item_detailed_info => $info
                                )
                            ));
                    }
                }

                array_push(
                    $folder_items, 
                    array(
                        PluginRegularFolderItem::media_url => 'dummy',
                        PluginRegularFolderItem::caption =>'%tr%loading',
                        PluginRegularFolderItem::view_item_params => array(
                            ViewItemParams::icon_width => ($view_type == 1 ? 63 : ($view_type == 2 ? 150 : 50)),
                            ViewItemParams::icon_height => (1 ? 63 : ($view_type == 2 ? 150 : 50)),
                            ViewItemParams::icon_path => ($view_type != 3 ? 'gui_skin://large_icons/movie.aai' : 'gui_skin://small_icons/movie.aai'),
                            ViewItemParams::item_detailed_icon_path => 'missing://'
                        )
                    ));

                ++$total_num;
            }
        }

        else if (HD::has_attribute($user_data, 'video_id'))
        {
	        $more_items_available = 0;
            $c = VideoCache::get($user_data->video_id);
            HD::decode_user_data($c, $media_str, $user_data);
	        $vod_info = $this->get_vod_info($media_url, &$plugin_cookies);
	        $series = $vod_info[PluginVodInfo::series];

	        $i = 0;
	        foreach($series as $s)
	        {
		        $info = '';
                $isnew = false;
                $video_id = $user_data->video_id;
                if (isset($plugin_cookies->$video_id))
                {
                    $isnew = !ListUtil::is_in_list($plugin_cookies->$video_id, $s[PluginVodSeriesInfo::playback_url]);
                }
                array_push
                (
                    $folder_items, 
                    array
                    (
                        PluginRegularFolderItem::media_url =>
                            HD::encode_user_data
                            (
                                array
                                (
					                'video_id' => $user_data->video_id,
					                'ndx_series' => $i,
                                    'url_series' => $s[PluginVodSeriesInfo::playback_url]
				                )
  			                ),
                            PluginRegularFolderItem::caption => ($isnew ? "[NEW] " . $s[PluginVodSeriesInfo::name] : $s[PluginVodSeriesInfo::name]),
                            PluginRegularFolderItem::view_item_params => array(
                                    ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                                    ViewItemParams::item_detailed_info => $info
                            )
                    )
		        );
		        ++$i;
	        }

	        $total_num = $i;
        }
    

        return array(
            PluginRegularFolderRange::total => $total_num,
            PluginRegularFolderRange::count => count($folder_items),
            PluginRegularFolderRange::more_items_available => $more_items_available,
            PluginRegularFolderRange::from_ndx => $from_ndx,
            PluginRegularFolderRange::items => $folder_items
        );
    }

    ///////////////////////////////////////////////////////////////////////
    private function get_episode_url($episode_ref, $video_quality)
    {	
        $url = $episode_ref;
		return($url);
    }
    
    public function get_vod_info($media_url, &$plugin_cookies)
    {
        if ($media_url === 'dummy')
            return array();

        HD::decode_user_data($media_url, $media_str, $user_data);

        $season_ref = "";
        if (!HD::has_attribute($user_data, 'season_ref'))
        {
            if (!HD::has_attribute($user_data, 'video_id'))
                throw new Exception('No season_ref or video_id');
            
            $season_ref = $user_data->video_id;
        }
        else
            $season_ref = $user_data->season_ref;

	    $ndx_series = 0;
        if (HD::has_attribute($user_data, 'ndx_series'))
		    $ndx_series = $user_data->ndx_series;
            
        $title = '';
        if (HD::has_attribute($user_data, 'season_title'))
            $title = $user_data->season_title;
		$authorize = 0;
        if (HD::has_attribute($user_data, 'authorize'))
            $authorize = $user_data->authorize;
        $descr = '';
        $icon_path = '';
	    $series = array();
        $series_urls = $this->parse_season($season_ref, $user_data->playlistItem,$user_data->season_title,$authorize, $plugin_cookies);
        $video_quality = isset($plugin_cookies->video_quality) ? $plugin_cookies->video_quality : 1;
		$this->allMediaUrl = $series_urls;
        $i = 0;
	    foreach ($series_urls as $s)
	    {
	        HD::decode_user_data($s, $media_str, $user_data);
            if ($i === 0)
            {
                if (HD::has_attribute($user_data, 'season_title'))
                    $title = $user_data->season_title;
                if (HD::has_attribute($user_data, 'description'))
                    $descr = $user_data->description;
                if (HD::has_attribute($user_data, 'poster_url'))
                    $icon_path = $user_data->poster_url;
            }

            $url = $user_data->episode_ref;
			if ((HD::has_attribute($user_data, 'playAll'))&&($season_ref == $url)){
				$ndx_series = $user_data->ndx_series;
				$descr = $user_data->description;
				$icon_path = $user_data->poster_url;
				$title = $user_data->season_title;
			}
		    if (strlen($user_data->episode_ref) > 0)
		    {
			    array_push
			    (
				    $series,
		            array
        		    (
                		PluginVodSeriesInfo::name => $user_data->episode_title,
	                	PluginVodSeriesInfo::playback_url => $url,
		                PluginVodSeriesInfo::playback_url_is_stream_url => 0
        		    )
			    );
                ++$i;
		    }
	    }
		
		$q = array(
            GUI_EVENT_KEY_D_BLUE => UserInputHandlerRegistry::create_action(
                        $this, 'dload'),
			GUI_EVENT_KEY_C_YELLOW => UserInputHandlerRegistry::create_action(
                        $this, 'like_dislike'),
			GUI_EVENT_KEY_URL => UserInputHandlerRegistry::create_action(
                        $this, 'add_to_playlist'),
			GUI_EVENT_KEY_CLEAR => UserInputHandlerRegistry::create_action(
                        $this, 'comment'),
        );
        $buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
		return array
        (
            PluginVodInfo::name => $title,
            PluginVodInfo::description => $descr,
            PluginVodInfo::poster_url => $icon_path,
            PluginVodInfo::initial_series_ndx => $ndx_series,
            PluginVodInfo::buffering_ms => $buf_time,
            PluginVodInfo::series => $series,
			PluginVodInfo::timer => ActionFactory::timer(5000),
			PluginVodInfo::actions => $q, 
			
        );
    }

    public function get_vod_stream_url($media_url, &$plugin_cookies)
    {
        $video_quality = isset($plugin_cookies->video_quality) ? $plugin_cookies->video_quality : 1;
		$use_marked = (HD::get_item('use_marked', &$plugin_cookies)!=='') ? HD::get_item('use_marked', &$plugin_cookies) : 'no';
        if (!preg_match("/m3u8/i",$media_url)){
			if (($use_marked == 'yes')&&(HD::plugin_login($plugin_cookies) == true)){
				HD::get_authorization_document(HOST_API_URL."/channels?part=id&mine=true", &$plugin_cookies);
				$tokens = HD::get_items('tokens', &$plugin_cookies);
				HD::http_get_document("https://www.youtube.com/user_watch?video_id=$media_url&eurl=https%3A%2F%2Fs%2Eytimg%2Ecom%2Fyt%2Fswf%2Fleanbacklite%5Fv3%2Eswf&el=leanback&ps=lbl&splay=1&ptk=youtube_multi&fmt=22&asv=2&access_token=".$tokens['access_token']);
			}
		$media_url = str_replace("http://", "http://mp4://", Youtube::retrieve_playback_url($media_url, false, $plugin_cookies));
		}
		return $this->get_episode_url($media_url, $video_quality);    
    }

    ///////////////////////////////////////////////////////////////////////

    private function get_loading_items()
    {
        $view_type = isset($plugin_cookies->view_type) ? $plugin_cookies->view_type : 2;
        $items = array(
            array
            (
                PluginRegularFolderItem::caption =>'%tr%loading',
                PluginRegularFolderItem::view_item_params => array(
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 10,
                    ViewItemParams::icon_width => ($view_type == 1 ? 63 : ($view_type == 2 ? 150 : 50)),
                    ViewItemParams::icon_height => (1 ? 63 : ($view_type == 2 ? 150 : 50)),
                    ViewItemParams::icon_path => ($view_type != 3 ? 'gui_skin://large_icons/movie.aai' : 'gui_skin://small_icons/movie.aai'),
                    ViewItemParams::item_caption_width => 850,
                    ViewItemParams::item_detailed_icon_path => 'missing://'
                ),
                PluginRegularFolderItem::media_url => 'dummy'
            )
        );

        return array(
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => 1,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items
        );
    }

    ///////////////////////////////////////////////////////////////////////
    private function General_main($media_url, &$plugin_cookies)
    {
        set_time_limit(0);
		$items = array();
		$regionCode = (HD::get_item('сountry', &$plugin_cookies)!=='') ? HD::get_item('сountry', &$plugin_cookies) : HD::country();
		$hl = (HD::get_item('local', &$plugin_cookies)!=='') ? HD::get_item('local', &$plugin_cookies) : 'en';
		HD::decode_user_data($media_url,$url,$user_data);
		if (isset($user_data->channelId)){
		$category_external_id = $user_data->channelId;
				$jsd = json_decode(HD::http_get_document(HOST_API_URL."/channels?part=snippet%2CcontentDetails&id=".$category_external_id."&key=".API_KEY), true);
				$category_name = str_remove_spec($jsd['items']['0']['snippet']['title']);
				$category_description = $jsd['items']['0']['snippet']['description'];
				$category_thumbnails = $jsd['items']['0']['snippet']['thumbnails']['medium']['url'];
				$category_url[$category_name . " [videos]"] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL."/search?part=snippet&locale=$hl&regionCode=$regionCode&channelId=".$category_external_id."&type=video&maxResults=50&key=".API_KEY."&pageToken=",)), $category_description, $category_thumbnails);
				$category_url[$category_name . " [playlists]"] = array ( HD::encode_user_data(array('subcategory_ref' => HOST_API_URL."/search?part=snippet&locale=$hl&regionCode=$regionCode&channelId=".$category_external_id."&type=playlist&maxResults=50&key=".API_KEY."&pageToken=",)), $category_description, $category_thumbnails);
				$category_url[$category_name . " [activities]"] = array ( HD::encode_user_data(array('subcategory_ref' => HOST_API_URL."/activities?part=snippet%2CcontentDetails&channelId=".$category_external_id."&maxResults=50&key=".API_KEY."&pageToken=",)), $category_description, $category_thumbnails);
				$category_url[$category_name . " [subscriptions]"] = array ( HD::encode_user_data(array('subcategory_ref' => HOST_API_URL."/subscriptions?part=snippet%2CcontentDetails&channelId=".$category_external_id."&maxResults=50&key=".API_KEY."&pageToken=",)), $category_description, $category_thumbnails);
				if (isset($jsd['items']['0']["contentDetails"]["relatedPlaylists"]))
					foreach ($jsd['items']['0']["contentDetails"]["relatedPlaylists"] as $key => $value)
							$category_url[$category_name . " [$key]"] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/playlistItems?part=snippet%2CcontentDetails%2Cstatus&playlistId=".$value."&maxResults=50&key=" . API_KEY . "&pageToken=",)), $category_description, $category_thumbnails);			
				$jsdq = json_decode(HD::http_get_document(HOST_API_URL."/search?eventType=live&order=date&part=snippet&channelId=".$category_external_id."&type=video&maxResults=50&key=". API_KEY), true);
				if ($jsdq['pageInfo']['totalResults'] > 0)
					foreach ($jsdq['items'] as $value)
					$category_url[str_remove_spec($value['snippet']['title']) . " [live]"] = array ( HD::encode_user_data(array('info' => '1', 'video_id' => $value['id']['videoId'], 'season_ref' => $value['id']['videoId'], 'playlistItem' => 0, 'season_title' => $value['snippet']['title'],)), $category_description, $category_thumbnails);
		}
		else if ($media_url == 'main_menu:chanell'){
			$category_url['#live broadcasts'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL."/search?eventType=live&part=snippet&type=video&maxResults=50&key=".API_KEY."&pageToken=",)), '', self::yt_channel_ico(7));
			$category_url['#upcoming broadcasts'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL."/search?eventType=upcoming&part=snippet&type=video&maxResults=50&key=".API_KEY."&pageToken=",)), '', self::yt_channel_ico(7));
			$category_url['#completed broadcasts'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL."/search?eventType=completed&part=snippet&type=video&maxResults=50&key=".API_KEY."&pageToken=",)), '', self::yt_channel_ico(7));
			$jsd = json_decode(HD::http_get_document(HOST_API_URL."/guideCategories?part=snippet&hl=$hl&regionCode=$regionCode&key=".API_KEY), true);
					foreach ($jsd['items'] as $value)
					$category_url[$value['snippet']['title']] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL."/channels?part=snippet&categoryId=".$value['id']."&hl=$hl&regionCode=$regionCode&maxResults=50&key=".API_KEY."&pageToken=",)), '', self::yt_channel_ico(0));
		}
		else{
			$category_url['%tr%popular'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL."/videos?part=snippet&chart=mostPopular&maxResults=50&regionCode=$regionCode&key=".API_KEY."&pageToken=",)), '', self::yt_channel_ico(0));
			
			$jsd = json_decode(HD::http_get_document(HOST_API_URL."/videoCategories?part=snippet&hl=$hl&locale=$hl&regionCode=$regionCode&key=".API_KEY), true);
			foreach ($jsd['items'] as $value)
			if ($value['snippet']['assignable'] == 1)
			$category_url[$value['snippet']['title']] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL."/videos?part=snippet&chart=mostPopular&hl=$hl&locale=$hl&maxResults=50&regionCode=$regionCode&videoCategoryId=".$value['id']."&key=".API_KEY."&pageToken=",)), '', self::yt_channel_ico($value['id']));
			
		}
		foreach ($category_url as $key => $itm){
			array_push
			(
				$items,
				array
				(
					PluginRegularFolderItem::caption => $key,
					PluginRegularFolderItem::view_item_params => array
					(
						ViewItemParams::icon_path => str_replace("https", "http", $itm[2]),
						ViewItemParams::item_layout => HALIGN_LEFT,
						ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
						ViewItemParams::icon_width => 40,
						ViewItemParams::icon_height => 40,
						ViewItemParams::item_detailed_info => "|$key|||".$itm[1],
						//ViewItemParams::item_caption_wrap_enabled => TRUE,
						ViewItemParams::item_caption_width => 1100
					),
					PluginRegularFolderItem::media_url => $itm[0]
				)
			);
			}
        return $items;
    }
	private function General_subscription($media_url, &$plugin_cookies)
    {
        set_time_limit(0);
		$items = array();
		$jsd = HD::get_authorization_document(HOST_API_URL."/channels?part=snippet&maxResults=50&mine=true&key=".API_KEY, &$plugin_cookies);
		if (isset ($jsd['error']))
		$category_url["%tr%authorization_error"] = array (HD::encode_user_data(array('subcategory_ref' => "error","authorize"=> 0)), '%tr%dialog_6', 'plugin_file://skins/error.png');	
		else{
		$category_description = $jsd['items']['0']['snippet']['title'].'||'.$jsd['items']['0']['snippet']['description'];
		$category_thumbnails = $jsd['items']['0']['snippet']['thumbnails']['medium']['url'];
		$category_url['%tr%my_subscriptions'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/subscriptions?part=snippet&maxResults=50&mine=true&key=" . API_KEY . "&pageToken=","authorize"=> 1)), $category_description, $category_thumbnails);
		$category_url['%tr%my_playlists'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/playlists?part=snippet%2Cstatus&maxResults=50&mine=true&key=" . API_KEY . "&pageToken=","authorize"=> 1)), $category_description, $category_thumbnails);
		$category_url['%tr%recommended'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/activities?part=snippet%2CcontentDetails&home=true&maxResults=50&key=" . API_KEY . "&pageToken=","authorize"=> 1)), $category_description, $category_thumbnails);
		$jsd_cd = HD::get_authorization_document(HOST_API_URL."/channels?part=contentDetails&maxResults=50&mine=true&key=".API_KEY, &$plugin_cookies);
		$category_url['%tr%likes'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/playlistItems?part=snippet%2CcontentDetails&maxResults=50&playlistId=".$jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['likes']."&key=" . API_KEY . "&pageToken=","authorize"=> 1)), $category_description, $category_thumbnails);
		$category_url['%tr%favorites'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/playlistItems?part=snippet%2CcontentDetails&maxResults=50&playlistId=".$jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['favorites']."&key=" . API_KEY . "&pageToken=","authorize"=> 1)), $category_description, $category_thumbnails);
		$category_url['%tr%uploads_video'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/playlistItems?part=snippet%2CcontentDetails&maxResults=50&playlistId=".$jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['uploads']."&key=" . API_KEY . "&pageToken=","authorize"=> 1)), $category_description, $category_thumbnails);
		$category_url['%tr%watch_history'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/playlistItems?part=snippet%2CcontentDetails&maxResults=50&playlistId=".$jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['watchHistory']."&key=" . API_KEY . "&pageToken=","authorize"=> 1)), $category_description, $category_thumbnails);
		$category_url['%tr%watch_later'] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/playlistItems?part=snippet%2CcontentDetails&maxResults=50&playlistId=".$jsd_cd['items']['0']['contentDetails']['relatedPlaylists']['watchLater']."&key=" . API_KEY . "&pageToken=","authorize"=> 1)), $category_description, $category_thumbnails);
		$category_url["Rating like"] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/videos?part=snippet&myRating=like&key=" . API_KEY . "&pageToken=","authorize"=> 1)), $category_description, $category_thumbnails);
		$category_url["Rating dislike"] = array (HD::encode_user_data(array('subcategory_ref' => HOST_API_URL. "/videos?part=snippet&myRating=dislike&key=" . API_KEY . "&pageToken=","authorize"=> 1)), $category_description, $category_thumbnails);
		}
		foreach ($category_url as $key => $itm){
			array_push
			(
				$items,
				array
				(
					PluginRegularFolderItem::caption => $key,
					PluginRegularFolderItem::view_item_params => array
					(
						ViewItemParams::icon_path => str_replace("https", "http", $itm[2]),
						ViewItemParams::item_layout => HALIGN_LEFT,
						ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
						ViewItemParams::icon_width => 40,
						ViewItemParams::icon_height => 40,
						ViewItemParams::item_detailed_info => "|$key|||".$itm[1],
						//ViewItemParams::item_caption_wrap_enabled => TRUE,
						ViewItemParams::item_caption_width => 1100
					),
					PluginRegularFolderItem::media_url => $itm[0]
				)
			);
			}
        return $items;
    }
    ///////////////////////////////////////////////////////////////////////

    private function get_main_menu_items($media_url, &$plugin_cookies)
    {
        HD::decode_user_data($media_url,$url,$user_data);
        FolderCache::clear();
		
	    if ($media_url === 'main_menu')
	    {
		    $items = array();
			$items_detail = unserialize(file_get_contents(DuneSystem::$properties['install_dir_path'].'/data/mm'));
			foreach ($items_detail as $value){
			if ((HD::plugin_login($plugin_cookies) !== true)&&($value['media_url']=='main_menu:subscription'))
			continue;
			array_push
				(
					$items,
					array
					(
						PluginRegularFolderItem::caption => $value['caption'],
						PluginRegularFolderItem::view_item_params => array(
								ViewItemParams::icon_path => self::get_skin_path($plugin_cookies) . $value['icon_path'],
								ViewItemParams::item_layout => HALIGN_CENTER,
								ViewItemParams::icon_valign => VALIGN_CENTER,
								ViewItemParams::item_paint_caption_within_icon => false,
								ViewItemParams::item_paint_caption => true,
								ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
						),
						PluginRegularFolderItem::media_url => $value['media_url']
					)
				);
			}
	    }
        else if ($media_url === 'main_menu:search')
	    {
		    $items = array();
            array_push
            (
                $items,
                array
                (
                    PluginRegularFolderItem::caption => '%tr%new_search',
                    PluginRegularFolderItem::view_item_params => self::$catalog_vip,
                    PluginRegularFolderItem::media_url =>
                        HD::encode_user_data
                        (
                            array('ser_feed' => '',
								)
                        )
                )
            );
			
		    $search_items = HD::get_items('search_items', &$plugin_cookies);
		    foreach ($search_items as $key => $item)
		    {
			    if ($item !== "")
			    {
				array_push
				    (
					    $items,
					    array
					    (
						    PluginRegularFolderItem::caption => "$item",
						    PluginRegularFolderItem::view_item_params => self::$catalog_vip,
						    PluginRegularFolderItem::media_url =>
							    HD::encode_user_data
							    (
								    array('ser_feed' => urlencode($item),
									'ser_link' => 'video'
									)
							    )
                        )
                    );
                }
            }
        }
        else if ($media_url === 'main_menu:fav')
	    {
		    $items = array();
		    $fav_items = isset($plugin_cookies->fav_items) ? $plugin_cookies->fav_items : '';
		    foreach (ListUtil::string_to_list($fav_items) as $item)
		    {
			    if ($item !== "")
			    {
				    $folderRange = $this->get_regular_folder_items(
							    HD::encode_user_data(array('fav' => $item)),
							    0,
							    $plugin_cookies
					   	    );

				    if (!$folderRange)
					    continue;
				    if ($folderRange[PluginRegularFolderRange::count] < 1)
					    continue;

				    array_push
				    (
					    $items,
					    $folderRange[PluginRegularFolderRange::items][0]
                    );
                }
            }
        }
	    elseif (($media_url === 'main_menu:videos')||(HD::has_attribute($user_data, 'channelId'))||($media_url === 'main_menu:chanell'))
	    {
            $items = $this->General_main($media_url, $plugin_cookies);
	    }
		elseif ($media_url === 'main_menu:subscription')
	    {
            FolderCache::clear();
			$items = $this->General_subscription($media_url, $plugin_cookies);
	    }
	    return 	array
	    (
		        PluginRegularFolderRange::total => count($items),
		        PluginRegularFolderRange::count => count($items),
	            PluginRegularFolderRange::more_items_available => false,
		        PluginRegularFolderRange::from_ndx => 0,
		        PluginRegularFolderRange::items => $items
	    );
	}
}

///////////////////////////////////////////////////////////////////////////

DefaultDunePluginFw::$plugin_class_name = 'GeneralPlugin';

///////////////////////////////////////////////////////////////////////////
?>
