﻿<?php
///////////////////////////////////////////////////////////////////////////
require_once 'utils.php';

class Cursor
{

	    private $m_feed;
	    private $m_feed_url;
	    private $m_items_count;
        private $m_last_ref;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($media_url)
    {
        if ($media_url === 'main_menu:fav')
            $this->m_feed_url = 'main_menu:fav';
        else
            HD::decode_user_data($media_url, $media_str, $this->m_feed_url);

        $this->m_items_count = 0;
        $this->m_feed = 0;
        $this->m_last_ref = "";
		$this->m_next_ref = '';
    }

    private function parse_page($url,$plugin_cookies)
    {
		$items = array();
		if (((HD::has_attribute($this->m_feed_url, "authorize"))&&($this->m_feed_url->authorize = 1))||(preg_match('|subscriptions\?part=snippet\%2CcontentDetails|', $url))){
			$url=explode("&order=",$url);
			$jsd = HD::get_authorization_document($url[0], &$plugin_cookies);
		}
		else
			$jsd = json_decode(HD::http_get_document($url), true);
		if (isset($jsd['nextPageToken']))
		$this->m_next_ref = $jsd['nextPageToken'];
		else
			$this->m_next_ref = 'stop';
		if (isset($jsd['items']))
        foreach ($jsd['items'] as $value){
			$playlistItem = 0;
			if (isset($value['id']['videoId']))
            $season_ref = $value['id']['videoId'];
			if (isset($value['id']['playlistId'])){
            $season_ref = $value['id']['playlistId'];
			$playlistItem = 1;
			}
			if (isset($value['id']['channelId'])){
            $season_ref = $value['id']['channelId'];
			$playlistItem = 2;
			}
			if (isset($value['snippet']['resourceId']['channelId'])){
            $season_ref = $value['snippet']['resourceId']['channelId'];
			$channelId = $value['snippet']['resourceId']['channelId'];
			$channelTitle = $value['snippet']['title'];
			$playlistItem = 2;
			}
			if ((isset($value['kind']))&&($value['kind']=='youtube#channel')){
            $season_ref = $value['id'];
			$channelTitle = $value['snippet']['title'];
			$channelId = $value['id'];
			$playlistItem = 2;
			}
			if ((isset($value['kind']))&&($value['kind']=='youtube#video')){
            $season_ref = $value['id'];
			$playlistItem = 0;
			}
			if ((isset($value['kind']))&&($value['kind']=='youtube#playlist')){
            $season_ref = $value['id'];
			$playlistItem = 1;
			}
			$liveBroadcastContent = '';
			if ((isset($value['snippet']['liveBroadcastContent']))&&($value['snippet']['liveBroadcastContent'] == 'live'))
				$liveBroadcastContent = '[live]';
			if (isset($value['snippet']['thumbnails']))
				foreach ($value['snippet']['thumbnails'] as $thumbnails)
				$season_image = str_replace("https", "http", $thumbnails['url']);
		
			$season_title = str_remove_spec($value['snippet']['title']);
			$season_desc = $value['snippet']['description'];
			if (isset($value['snippet']['channelTitle']))
			$channelTitle = $value['snippet']['channelTitle'];
			if (isset($value['snippet']['channelId']))
			$channelId = $value['snippet']['channelId'];
			if (isset($value['snippet']['type'])){
			$type = $value['snippet']['type'];
			if (isset($value['contentDetails'][$type]['resourceId']['videoId']))
				$season_ref = $value['contentDetails'][$type]['resourceId']['videoId'];
			if (isset($value['contentDetails'][$type]['videoId']))
				$season_ref = $value['contentDetails'][$type]['videoId'];
			$playlistItem = 0;
			$liveBroadcastContent = "[$type]";
			}
			if (isset($value['contentDetails']['videoId'])){
            $season_ref = $value['contentDetails']['videoId'];
			$playlistItem = 0;
			}
			$authorize = 0;
			if ((isset($value['status']['privacyStatus']))&&($value['status']['privacyStatus']=='private'))
			$authorize = 1;
			$season_date = '';
			if (isset($value['snippet']['publishedAt']))
			$season_date = str_replace(array ("T",".000Z"), " ", $value['snippet']['publishedAt']);
			$itemID = false;
			if (
			((isset($value['id']))&&($value['kind']=='youtube#playlistItem'))||
			((isset($value['id']))&&($value['kind']=='youtube#subscription'))||
			((isset($value['id']))&&($value['kind']=='youtube#playlist'))
				)
				$itemID = $value['id'];
            array_push
            (
                $items,
                HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'season_title' => $season_title,
                        'season_ref' => $season_ref,
                        'season_image' => $season_image,
						'season_desc' => $season_desc,
						'season_date' => $season_date,
						'playlistItem' => $playlistItem,
						'channelTitle' => $channelTitle,
						'channelId' => $channelId,
						'lBC' => $liveBroadcastContent,
						'authorize'=> $authorize,
						'itemID' => $itemID,
                        'is_has_new' => false
                    )
                )
            );
            ++$this->m_items_count;
        }

        return $items;
    }

    private function parse_subcategory($current_sort_page,$plugin_cookies)
    {
        $subcategory = $this->m_feed_url;
        $url = $subcategory->subcategory_ref . "&order=$current_sort_page";
        if ($this->m_feed > 0)
            $url = $subcategory->subcategory_ref . $this->m_next_ref."&order=$current_sort_page";
        return $this->parse_page($url,$plugin_cookies);
    }

    ///////////////////////////////////////////////////////////////////////
    private function parse_search_result($search,$plugin_cookies)
    {	
        return $this->parse_page($search,$plugin_cookies);
    }
    ///////////////////////////////////////////////////////////////////////

    private function get_next_fav(&$plugin_cookies)
    {
		$fav_items = HD::get_items('fav_items', &$plugin_cookies);     
        $ref = "";
        $n = 0;
        foreach ($fav_items as $key => $item)
        {
            if ($item == "")
                continue;
            if ($n == $this->m_feed)
                $ref = $item;
            ++$n;
        }
        if ($ref == "")
            return false;
        $items = array();
        $c = VideoCache::get($ref);
        if (!is_null($c))
        {
            array_push
            (
                $items,
                $c
            );
            ++$this->m_items_count;
            return $items;
        }
		$fav_links = HD::get_items('fav_items_link', &$plugin_cookies);	
		if (isset($fav_links[$ref]))
		{
			$season_title = $fav_links[$ref]['title'];
			$season_image = $fav_links[$ref]['img'];
			$playlistItem = $fav_links[$ref]['playlistItem'];
		}
        array_push
        (
            $items,
            HD::encode_user_data
            (
                array
                (
                    'video_id' => $ref,
                    'season_title' => $season_title,
                    'season_ref' => $ref,
                    'season_image' => $season_image,
                    'is_has_new' => false,
					'playlistItem' => $playlistItem,
					'authorize'=> 0,
					'itemID' => false,
                )
            )
        );

        ++$this->m_items_count;

        return $items;
    }
    ///////////////////////////////////////////////////////////////////////

    public function next_chunk($plugin_cookies)
    {
	    $current_sort_page = (HD::get_item('sort_page', &$plugin_cookies)!=='') ? HD::get_item('sort_page', &$plugin_cookies) : 'relevance';
		
		$search_local = (HD::get_item('search_local', &$plugin_cookies)!=='') ? HD::get_item('search_local', &$plugin_cookies) : 'yes';
	    $items = array();
        if ($this->m_feed_url === 'main_menu:fav')
        {
            $items = $this->get_next_fav($plugin_cookies);
            ++$this->m_feed;
            if ($items === false)
                return false;
            
            return count($items) > 0 ? $items : false;
        }
	    if (HD::has_attribute($this->m_feed_url, 'ser_feed'))
	    {
			$current_sort_page = (HD::get_item('sort_page_search', &$plugin_cookies)!=='') ? HD::get_item('sort_page_search', &$plugin_cookies) : 'relevance';
			if ($this->m_next_ref == 'stop')
				return false;
			$current_videoDefinition_page ='';
			if ($this->m_feed_url->ser_link == 'video')
				$current_videoDefinition_page = (HD::get_item('videoDefinition_page', &$plugin_cookies)!=='') ? HD::get_item('videoDefinition_page', &$plugin_cookies) : '&videoDefinition=any';
			if ($search_local == 'yes'){
				$current_сountry = (HD::get_item('сountry', &$plugin_cookies)!=='') ? HD::get_item('сountry', &$plugin_cookies) : HD::country();
				$current_local = (HD::get_item('local', &$plugin_cookies)!=='') ? HD::get_item('local', &$plugin_cookies) : 'en';
				$search_text = HOST_API_URL . "/search?order=$current_sort_page&part=snippet&q=".$this->m_feed_url->ser_feed."&type=".$this->m_feed_url->ser_link."&maxResults=50&relevanceLanguage=$current_local&regionCode=$current_сountry&pageToken=".$this->m_next_ref."$current_videoDefinition_page&key=".API_KEY;
			}
            else
				$search_text = HOST_API_URL . "/search?order=$current_sort_page&part=snippet&q=".$this->m_feed_url->ser_feed."&type=".$this->m_feed_url->ser_link."&maxResults=50&pageToken=".$this->m_next_ref."$current_videoDefinition_page&key=".API_KEY;
			$items = $this->parse_search_result($search_text,$plugin_cookies);
            ++$this->m_feed;
            if ($items === false)
                return false;
            return count($items) > 0 ? $items : false;
	    }
        else if (HD::has_attribute($this->m_feed_url, 'subcategory_ref'))
        {
			if ($this->m_next_ref == 'stop')
				return false;
			$items = $this->parse_subcategory($current_sort_page, $plugin_cookies);
            ++$this->m_feed;
            if ($items === false)
                return false;
            return count($items) > 0 ? $items : false;
        }
        return false;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
