<?php
///////////////////////////////////////////////////////////////////////////
require_once 'utils.php';
class HD
{
    public static function is_map($a)
    {
        return is_array($a) &&
            array_diff_key($a, array_keys(array_keys($a)));
    }

    ///////////////////////////////////////////////////////////////////////

    public static function has_attribute($obj, $n)
    {
        $arr = (array) $obj;
        return isset($arr[$n]);
    }
    ///////////////////////////////////////////////////////////////////////

    public static function get_map_element($map, $key)
    {
        return isset($map[$key]) ? $map[$key] : null;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function starts_with($str, $pattern)
    {
        return strpos($str, $pattern) === 0;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function format_timestamp($ts, $fmt = null)
    {
        // NOTE: for some reason, explicit timezone is required for PHP
        // on Dune (no builtin timezone info?).

        if (is_null($fmt))
            $fmt = 'Y:m:d H:i:s';

        $dt = new DateTime('@' . $ts);
        return $dt->format($fmt);
    }

    ///////////////////////////////////////////////////////////////////////

    public static function format_duration($secs)
    {
        $n = intval($secs);

        if (strlen($secs) <= 0 || $n <= 0)
            return "--:--";

        // XXX (tvigle specific) $n = $n / 1000;
        $hours = $n / 3600;
        $remainder = $n % 3600;
        $minutes = $remainder / 60;
        $seconds = $remainder % 60;

        if (intval($hours) > 0)
        {
            return sprintf("%d:%02d:%02d", $hours, $minutes, $seconds);
        }
        else
        {
            return sprintf("%02d:%02d", $minutes, $seconds);
        }
    }
	public static function plugin_login($plugin_cookies)
    {
		$plugin_login = false;
		$tokens = self::get_items('tokens', &$plugin_cookies);
		if ((isset($tokens['access_token']))&&(isset($tokens['refresh_token'])))
			$plugin_login = true;
		return $plugin_login;
	}
    ///////////////////////////////////////////////////////////////////////

    public static function encode_user_data($a, $b = null)
    {
        $media_url = null;
        $user_data = null;

        if (is_array($a) && is_null($b))
        {
            $media_url = '';
            $user_data = $a;
        }
        else
        {
            $media_url = $a;
            $user_data = $b;
        }

        if (!is_null($user_data))
            $media_url .= '||' . json_encode($user_data);

        return $media_url;
    }
	public static function get_data_path(&$plugin_cookies) {
		$data_type = isset($plugin_cookies->data_type) ?
        $plugin_cookies->data_type : '1';
		$data_dir = isset($plugin_cookies->data_dir) ? 
		$plugin_cookies->data_dir : '/';
    	if ($data_type == 1)
		$data_path = DuneSystem::$properties['data_dir_path'];
		else if ($data_type == '/D')
		$data_path = "/D".$data_dir;
		else if ($data_type == 2){
		$data_smb_user = isset($plugin_cookies->data_smb_user) ? 
		$plugin_cookies->data_smb_user : 'guest';
		$data_smb_pass = isset($plugin_cookies->data_smb_pass) ? 
		$plugin_cookies->data_smb_pass : 'guest';
		$data_ip_path = isset($plugin_cookies->data_ip_path) ? 
		$plugin_cookies->data_ip_path : '';
		$tmp = explode('/', $data_ip_path);
		$ip_lan = $tmp[0].'/'.$tmp[1];
		$tmp = explode($ip_lan, $data_ip_path);
		$folder_lan = $tmp[1];
		$path_m = '/tmp/mnt/smb/path_YTB';
		$data_path = $path_m .'/'. $folder_lan;
		$data_path = preg_replace("/(\/{2,})/","/",$data_path);
		if (!file_exists($data_path)) {
		if (!file_exists($path_m))
		shell_exec("mkdir $path_m");
		shell_exec('mount -t cifs -o rw,username='.$data_smb_user.',password='.$data_smb_pass.' "//'.$ip_lan.'" '.$path_m); }
		}
		else	
			$data_path = $data_type.$data_dir;
		return $data_path;
    }
	public static function get_dload_path(&$plugin_cookies) {
		$dload_type = isset($plugin_cookies->path_dload) 
		? $plugin_cookies->path_dload : '/D';
		$dload_dir = isset($plugin_cookies->dload_dir) ? 
		$plugin_cookies->dload_dir : '/';
		if ($dload_type == 1){
		$dload_smb_user = isset($plugin_cookies->dload_smb_user) ? 
		$plugin_cookies->dload_smb_user : 'guest';
		$dload_smb_pass = isset($plugin_cookies->dload_smb_pass) ? 
		$plugin_cookies->dload_smb_pass : 'guest';
		$dload_ip_path = isset($plugin_cookies->dload_ip_path) ? 
		$plugin_cookies->dload_ip_path : '';
		$tmp = explode('/', $dload_ip_path);
		$ip_lan = $tmp[0].'/'.$tmp[1];
		$tmp = explode($ip_lan, $dload_ip_path);
		$folder_lan = $tmp[1];
		$path_m = '/tmp/mnt/smb/path_YT_dload';
		$dload_path = $path_m .'/'. $folder_lan;
		$dload_path = preg_replace("/(\/{2,})/","/",$dload_path);
		if (!file_exists($dload_path)){
		if (!file_exists($path_m))
		shell_exec("mkdir $path_m");
		shell_exec('mount -t cifs -o rw,username='.$dload_smb_user.',password='.$dload_smb_pass.' "//'.$ip_lan.'" '.$path_m); 
		}
		}
		else	
			$dload_path = $dload_type.$dload_dir;
		return $dload_path;
    }
	public static function get_items($path,&$plugin_cookies) {
	$items = array();
	$data_path = self::get_data_path(&$plugin_cookies);
	$link = $data_path . '/'. $path;
			if (file_exists($link)){
			$doc = file_get_contents($link);
			$items = unserialize($doc);}
	return $items;
	}
	public static function save_items($path, $items, &$plugin_cookies) {
	$data_path = self::get_data_path(&$plugin_cookies);
	$link = $data_path . '/'. $path;
	$skey = serialize($items);
						$data = fopen($link,"w");
						if (!$data)
							{
							return ActionFactory::show_title_dialog("Не могу записать items Что-то здесь не так!!!");
							}
						fwrite($data, $skey);
						@fclose($data);
	}
	
	public static function save_items_tmp($path, $items) {
	$data_path = DuneSystem::$properties['tmp_dir_path']. '/' .$path;
	$skey = serialize($items);
						$data = fopen($data_path,"w");
						if (!$data)
							{
							return ActionFactory::show_title_dialog("Не могу записать items Что-то здесь не так!!!");
							}
						fwrite($data, $skey);
						@fclose($data);
	}
	
	public static function get_items_tmp($path) {
	$item = '';
	$data_path = DuneSystem::$properties['tmp_dir_path']. '/' .$path;
			if (file_exists($data_path))
			$item = unserialize(file_get_contents($data_path));
	return $item;
	}
	
	public static function save_item($path, $item, &$plugin_cookies) {
	$data_path = self::get_data_path(&$plugin_cookies);
	$link = $data_path . '/'. $path;
						$data = fopen($link,"w");
						if (!$data)
							{
							return ActionFactory::show_title_dialog("Не могу записать items Что-то здесь не так!!!");
							}
						fwrite($data, $item);
						@fclose($data);
	}
	public static function get_item($path,&$plugin_cookies) {
	$item = '';
	$data_path = self::get_data_path(&$plugin_cookies);
	$link = $data_path . '/'. $path;
			if (file_exists($link))
			$item = file_get_contents($link);
	return $item;
	}
	public static function country()
    {
	$country_code = parse_ini_file("/config/location_info.properties");
	return $country_code['country_code_2'];
	}
    ///////////////////////////////////////////////////////////////////////

    public static function decode_user_data($media_url_str, &$media_url, &$user_data)
    {
        $idx = strpos($media_url_str, '||');

        if ($idx === false)
        {
            $media_url = $media_url_str;
            $user_data = null;
            return;
        }

        $media_url = substr($media_url_str, 0, $idx);
        $user_data = json_decode(substr($media_url_str, $idx + 2));
    }

    ///////////////////////////////////////////////////////////////////////

    public static function http_get_document($url, $opts = null)
    {
        $ch = curl_init();
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,    false);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,    10);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION,    1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,    true);
        curl_setopt($ch, CURLOPT_TIMEOUT,           10);
        curl_setopt($ch, CURLOPT_USERAGENT,         "Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1");//'DuneHD/1.0');
		curl_setopt($ch, CURLOPT_ENCODING,          1);
        curl_setopt($ch, CURLOPT_URL,               $url);

        if (isset($opts))
        {
            foreach ($opts as $k => $v)
                curl_setopt($ch, $k, $v);
        }
		if (!preg_match('|user_watch|', $url))
        hd_print("HTTP fetching '$url'...");

        $content = curl_exec($ch);
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        if($content === false)
        {
            $err_msg = "HTTP error: $http_code (" . curl_error($ch) . ')';
            hd_print($err_msg);
            return '';
            //throw new Exception($err_msg);
        }

        if ($http_code != 200)
        {
            $err_msg = "HTTP request failed ($http_code)";
			if (!preg_match('|user_watch|', $url))
            hd_print($err_msg);
            return '';
            //throw new Exception($err_msg);
        }

        hd_print("HTTP OK ($http_code)");

        curl_close($ch);

        return $content;
    }
	public static function get_authorization_document($url, &$plugin_cookies, $post = null)
    {
		$tokens = self::get_items('tokens', &$plugin_cookies);
		$ch = curl_init();
		if ($post==true){
		if ($post == 'delete'){
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");
		}
		else{
		curl_setopt($ch, CURLOPT_POST,              true);
		curl_setopt($ch, CURLOPT_POSTFIELDS,		$post);
		curl_setopt($ch, CURLOPT_HTTPHEADER, 		array("Content-Type: application/json"));
		}
		}
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,    false);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,    10);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION,    1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,    true);
        curl_setopt($ch, CURLOPT_TIMEOUT,           10);
        curl_setopt($ch, CURLOPT_USERAGENT,         "Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1");//'DuneHD/1.0');
		curl_setopt($ch, CURLOPT_ENCODING,          1);
        curl_setopt($ch, CURLOPT_URL,               $url.'&access_token='.$tokens['access_token']);
        if (isset($opts))
        {
            foreach ($opts as $k => $v)
            curl_setopt($ch, $k, $v);
        }
        hd_print("HTTP fetching '$url'...");
        $content = curl_exec($ch);
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        if($content === false)
        {
            $err_msg = "HTTP error: $http_code (" . curl_error($ch) . ')';
            hd_print($err_msg);
            return '';
        }
		curl_close($ch);
        if ($http_code == 401)
        {
		$jsdr = json_decode(self::http_post_document('https://accounts.google.com/o/oauth2/token',"client_id=".CLIENT_ID."&client_secret=".CLIENT_SECRET."&refresh_token=".$tokens['refresh_token']."&grant_type=refresh_token" ), true);
		if (isset($jsdr['access_token'])){
		$tokens['access_token'] = $jsdr['access_token'];
		$tokens['expires_in'] = $jsdr['expires_in'];
		$tokens['token_type'] = $jsdr['expires_in'];
		self::save_items('tokens', $tokens,&$plugin_cookies);
		$access_token = $tokens['access_token'];
		$ch = curl_init();
		if ($post==true){
		if ($post == 'delete'){
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");
		}
		else{
		curl_setopt($ch, CURLOPT_POST,              true);
		curl_setopt($ch, CURLOPT_POSTFIELDS,		$post);
		curl_setopt($ch, CURLOPT_HTTPHEADER, 		array("Content-Type: application/json"));
		}
		}
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,    false);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,    10);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION,    1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,    true);
        curl_setopt($ch, CURLOPT_TIMEOUT,           10);
        curl_setopt($ch, CURLOPT_USERAGENT,         "Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1");//'DuneHD/1.0');
		curl_setopt($ch, CURLOPT_ENCODING,          1);
        curl_setopt($ch, CURLOPT_URL,               $url.'&access_token='.$tokens['access_token']);
        if (isset($opts))
        {
            foreach ($opts as $k => $v)
            curl_setopt($ch, $k, $v);
        }
        hd_print("HTTP fetching '$url'...");
        $content = curl_exec($ch);
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        if($content === false)
        {
            $err_msg = "HTTP error: $http_code (" . curl_error($ch) . ')';
            hd_print($err_msg);
            return '';
        }
		curl_close($ch);
		}
		else
			print_r ($jsdr);
        }
        hd_print("HTTP OK ($http_code)");
		$jsd = json_decode($content, true);
        return $jsd;
    }
	///////////////////////////////////////////////////////////////////////////
	public static function http_get_document_cookie($url, $referer, $opts = null)
    {
        $ch = curl_init();
		curl_setopt($ch, CURLOPT_REFERER, 			$referer);
		curl_setopt($ch, CURLOPT_COOKIEJAR,         '/tmp/vk.cookies');
        curl_setopt($ch, CURLOPT_COOKIEFILE,    	'/tmp/vk.cookies');
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,    10);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION,    1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,    true);
        curl_setopt($ch, CURLOPT_TIMEOUT,           10);
        curl_setopt($ch, CURLOPT_USERAGENT,         "Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1");//'DuneHD/1.0');
		curl_setopt($ch, CURLOPT_ENCODING,          1);
        curl_setopt($ch, CURLOPT_URL,               $url);

        if (isset($opts))
        {
            foreach ($opts as $k => $v)
                curl_setopt($ch, $k, $v);
        }

        hd_print("HTTP fetching '$url'...");

        $content = curl_exec($ch);
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        if($content === false)
        {
            $err_msg = "HTTP error: $http_code (" . curl_error($ch) . ')';
            hd_print($err_msg);
            return '';
            //throw new Exception($err_msg);
        }

        if ($http_code != 200)
        {
            $err_msg = "HTTP request failed ($http_code)";
            hd_print($err_msg);
            return '';
            //throw new Exception($err_msg);
        }

        hd_print("HTTP OK ($http_code)");

        curl_close($ch);

        return $content;
    }
	///////////////////////////////////////////////////////////////////////////////////////
	public static function http_get_document_login($url, $post_data, $referer, $opts = null)
    {
        $ch = curl_init();
		curl_setopt($ch, CURLOPT_REFERER, 			$referer);
		curl_setopt($ch, CURLOPT_COOKIEJAR,         '/tmp/vk.cookies');
        curl_setopt($ch, CURLOPT_COOKIEFILE,    	'/tmp/vk.cookies');
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,    10);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION,    1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,    true);
        curl_setopt($ch, CURLOPT_TIMEOUT,           10);
		curl_setopt($ch, CURLOPT_POST,              true);
		curl_setopt($ch, CURLOPT_POSTFIELDS,		$post_data);
		curl_setopt($ch, CURLOPT_HEADER, 			0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 	0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 	0);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 	1);
        curl_setopt($ch, CURLOPT_USERAGENT,         "Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1");
		curl_setopt($ch, CURLOPT_ENCODING,          1);
        curl_setopt($ch, CURLOPT_URL,               $url);

        if (isset($opts))
        {
            foreach ($opts as $k => $v)
                curl_setopt($ch, $k, $v);
        }

        hd_print("HTTP fetching '$url'...");

        $content = curl_exec($ch);
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        if($content === false)
        {
            $err_msg = "HTTP error: $http_code (" . curl_error($ch) . ')';
            hd_print($err_msg);
            return '';
            //throw new Exception($err_msg);
        }

        if ($http_code != 200)
        {
            $err_msg = "HTTP request failed ($http_code)";
            hd_print($err_msg);
            return '';
            //throw new Exception($err_msg);
        }

        hd_print("HTTP OK ($http_code)");

        curl_close($ch);

        return $content;
    }
	//////////////////////////////////////////////////////////////////////////////////////////
	public static function http_get_document_torrent($url, $post_data, $referer, $opts = null)
    {
        $ch = curl_init();
		curl_setopt($ch, CURLOPT_REFERER, 			$referer);
		curl_setopt($ch, CURLOPT_COOKIEJAR,         '/tmp/vk.cookies');
        curl_setopt($ch, CURLOPT_COOKIEFILE,    	'/tmp/vk.cookies');
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT,    10);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION,    1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,    true);
        curl_setopt($ch, CURLOPT_TIMEOUT,           10);
		curl_setopt($ch, CURLOPT_POST,              true);
		curl_setopt($ch, CURLOPT_POSTFIELDS,		$post_data);
		curl_setopt($ch, CURLOPT_HEADER, 			0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 	0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 	0);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 	1);
        curl_setopt($ch, CURLOPT_USERAGENT,         "Mozilla/5.0 (Windows NT 5.1; rv:7.0.1) Gecko/20100101 Firefox/7.0.1");
		curl_setopt($ch, CURLOPT_ENCODING,          1);
        curl_setopt($ch, CURLOPT_URL,               $url);

        if (isset($opts))
        {
            foreach ($opts as $k => $v)
                curl_setopt($ch, $k, $v);
        }

        hd_print("HTTP fetching '$url'...");

        $content = curl_exec($ch);
        $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

        if($content === false)
        {
            $err_msg = "HTTP error: $http_code (" . curl_error($ch) . ')';
            hd_print($err_msg);
            return '';
            //throw new Exception($err_msg);
        }

        if ($http_code != 200)
        {
            $err_msg = "HTTP request failed ($http_code)";
            hd_print($err_msg);
            return '';
            //throw new Exception($err_msg);
        }

        hd_print("HTTP OK ($http_code)");

        curl_close($ch);

        return $content;
    }
    ///////////////////////////////////////////////////////////////////////

    public static function http_post_document($url, $post_data)
    {
        return self::http_get_document($url,
            array
            (
                CURLOPT_POST => true,
                CURLOPT_POSTFIELDS => $post_data
            ));
    }

    ///////////////////////////////////////////////////////////////////////

    public static function parse_xml_document($doc)
    {
        $xml = simplexml_load_string($doc);

        if ($xml === false)
        {
            hd_print("Error: can not parse XML document.");
            hd_print("XML-text: $doc.");
            throw new Exception('Illegal XML document');
        }

        return $xml;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function make_json_rpc_request($op_name, $params)
    {
        static $request_id = 0;

        $request = array
        (
            'jsonrpc' => '2.0',
            'id' => ++$request_id,
            'method' => $op_name,
            'params' => $params
        );

        return $request;
    }

    ///////////////////////////////////////////////////////////////////////////

    public static function get_mac_addr()
    {
        static $mac_addr = null;

        if (is_null($mac_addr))
        {
            $mac_addr = shell_exec(
                'ifconfig  eth0 | head -1 | sed "s/^.*HWaddr //"');

            $mac_addr = trim($mac_addr);
        }

        return $mac_addr;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function get_out_type_code($op_code)
    {
        static $map = null;

        if (is_null($map))
        {
            $map = array
            (
                PLUGIN_OP_GET_FOLDER_VIEW           => PLUGIN_OUT_DATA_PLUGIN_FOLDER_VIEW,
                PLUGIN_OP_GET_NEXT_FOLDER_VIEW      => PLUGIN_OUT_DATA_PLUGIN_FOLDER_VIEW,
                PLUGIN_OP_GET_REGULAR_FOLDER_ITEMS  => PLUGIN_OUT_DATA_PLUGIN_REGULAR_FOLDER_RANGE,
                PLUGIN_OP_HANDLE_USER_INPUT         => PLUGIN_OUT_DATA_GUI_ACTION,
                PLUGIN_OP_GET_TV_INFO               => PLUGIN_OUT_DATA_PLUGIN_TV_INFO,
                PLUGIN_OP_GET_DAY_EPG               => PLUGIN_OUT_DATA_PLUGIN_TV_EPG_PROGRAM_LIST,
                PLUGIN_OP_GET_TV_PLAYBACK_URL       => PLUGIN_OUT_DATA_URL,
                PLUGIN_OP_GET_TV_STREAM_URL         => PLUGIN_OUT_DATA_URL,
                PLUGIN_OP_GET_VOD_INFO              => PLUGIN_OUT_DATA_PLUGIN_VOD_INFO,
                PLUGIN_OP_GET_VOD_STREAM_URL        => PLUGIN_OUT_DATA_URL,
                PLUGIN_OP_CHANGE_TV_FAVORITES       => PLUGIN_OUT_DATA_GUI_ACTION
            );
        }

        if (!isset($map[$op_code]))
        {
            hd_print("Error: get_out_type_code(): unknown operation code: '$op_code'.");
            throw new Exception("Uknown operation code");
        }

        return $map[$op_code];
    }
}

///////////////////////////////////////////////////////////////////////////
?>
